CLAUSES
	split(H,[A|L1],[A|L2],L3):-
		A <= H, !, split(H,L1,L2,L3).
	split(H,[A|L1],L2,[A|L3]):-
		A > H, !, split(H,L1,L2,L3).
	split(_,[],[],[]).
	
	sort([],[]):-!.
	sort([H|T],L):-
		split(H,T,L1,L2), sort(L1,Lx), sort(L2,Ly),
		append(Lx,[H|Ly],L).
		
	for(X,X,_).
	for(I,A,B) :- B>A, A1=A+1, for(I,A1,B).
	
	repeat_for(X,X).
	repeat_for(I,N) :- N1=N+1, repeat_for(I,N1).
	
	for_each( H,[H|_] ).
	for_each( I,[_|T] ) :- for_each( I,T ).

	index(0,[H|_],H):-!.
	index(N,[_|T],S):- N1=N-1,!,index(N1,T,S).

	append([],X,X):-!.
	append([X|L1],L2,[X|L3]):-append(L1,L2,L3).

	delete([],_,[]):-!.
	delete([H|T],H,T):-!.
	delete([H|T],H1,[H|T1]) :- !, delete(T,H1,T1).

	read_source( _ ) :-
		chain_delete( dba,"source" ),
		btndx(Index), bt_close( dba,Index ), bt_delete( dba,"ndx" ), 
		bt_create(dba,"ndx",Index1,5,4),
		retractall(btndx(_)), assert(btndx(Index1)), fail.
	read_source( Fn ) :-
		openread(arquivo,Fn),
		readdevice(OldDev),
		readdevice(arquivo),
		btndx(Index),
		repeat_for(I,1),
		readln(Lin),
		chain_inserta( dba,"source",source,s(I,Lin),Ref ),
		str_int(S,I),
		key_insert( dba,Index,S,Ref ),
		eof(arquivo), !,
		readdevice(OldDev),
		closefile(arquivo).
		
	goto_line( N ) :-
		shiftwindow(OldW), shiftwindow(2),
		N1=N-2,
		makewindow(_,_,_,_,_,_,H,W),
		N2=N+H-5, W1=W-2,
		list_lines(N1,N2,W1),
		field_attr(0,0,1,ATTR),
		reverseattr(ATTR,RATTR),
		field_attr(2,0,W1,RATTR),
		shiftwindow(OldW), !.
	goto_line( N ) :-
		readfilename(10,10,6,6,"cob","",Fn),
		read_source(Fn),
		!, goto_line( N ).
		
	list_lines( IL,FL,_ ) :-
		listed( IL,FL ), !.
	list_lines( IL,FL,Wid ) :-
		btndx(Index),
		retractall(listed(_,_)),
		assert(listed(IL,FL)),
		str_int(S,FL),
		key_search(dba,Index,S,Ref), !,
		Row = FL-IL+1,
		show_lines( Ref,Row,Wid ).
	
	show_lines( _,0,_ ) :- !.
	show_lines( Ref,Row,Wid ) :-
		chain_next( dba,Ref,Ref1 ),
		ref_term( dba,source,Ref,s(I,S1) ),
		format( S,"%d:%s",I,S1 ),
		Row1 = Row-1,
		field_str( Row1,0,Wid,S ), !,
		show_lines( Ref1,Row1,Wid ).
	show_lines( Ref,Row,Wid ) :-
		Row1 = Row-1,
		field_str( Row1,0,Wid,"" ), !,
		show_lines( Ref,Row1,Wid ).
		
	link_next_bp( BP,BP,_ ).
	link_next_bp( Next_BP,BP,Seg ) :- memword(Seg,BP,BP1),
			link_next_bp( Next_BP,BP1,Seg ).
		
	current_ip( CS,IP ) :-
		proc_ptr(Seg,Off0), term_process(TP),
		Off = Off0 + TP * 35,
		Off_ss = Off + 21, Off_bp = Off + 15,
		Off_base = Off + 33, 
		memword( Seg,Off_base,Base ), Base1 = Base - 2,
		memword( Seg,Off_ss,J_ss ), 
		memword( Seg,Off_bp,J_bp ),
		link_next_bp( BP,J_bp,J_ss ),	/* loop until [BP]==Base1 */
		memword( J_ss,BP,Base2 ),
		Base1 = Base2,
		BP1 = BP + 2,
		BP2 = BP + 4,
		memword( J_ss,BP1,IP ), 
		memword( J_ss,BP2,CS ), !.
	
	findline( Lin ) :-
		current_ip(_,IP),
		l(Lin,IP,_,_,_), !.
	findline( Lin ) :-
		current_ip( _,IP ),
		l(Lin,I,_,_,_), IP>=I, !.
	
	readunsigned( U ) :-
		readchar(I2),readchar(I1), bitleft(I1,8,I1a),
		bitor(I1a,I2,U).

	readfarptr( Segment,Offset ) :-
		readunsigned(Offset), readunsigned(Segment).
		/*ptr_dword(Ptr,Segment,Offset).*/

/*	frontlabel( Str, F, R ) :-
		fronttoken( Str,Str1,Str2 ),
		frontchar( Str1,'@',_ ), !,
		fronttoken( Str2,Str3,R ),
		concat( "@",Str3,F ).
	frontlabel( Str, F, R ) :-
		fronttoken( Str,F1,R1 ),
		str_int( F1,_ ), !,
		fronttoken( R1,F2,R ),
		concat( F1,F2,F ).
	frontlabel( Str,F,R ) :-
		fronttoken( Str,F,R ),!.
*/
	frontname( Str, F, R, Typ ) :-		/* $Lin 0 Addr */
		frontchar( Str,'$',Str1 ),
		fronttoken( Str1,F,Str2 ),
		fronttoken( Str2,Kind,Str3 ),
		str_int( Kind,0 ), !, Typ=2,
		fronttoken( Str3,Address,R ),
		str_int( F,Lin ), str_int( Address,Addr ),
		asserta( l(Lin,Addr,"","",0) ).
	frontname( Str, F, R, Typ ) :-		/* $Lin Kind Addr Label */
		frontchar( Str,'$',Str1 ),
		fronttoken( Str1,F,Str2 ),
		fronttoken( Str2,Kind,Str3 ),
		str_int( Kind,K ), K>=1, K<=4, !, Typ=2,
		fronttoken( Str3,Address,Str4 ),
		str_int( F,Lin ), str_int( Address,Addr ),
		frontlabel( Str4,Label,R ),
		asserta( l(Lin,Addr,Label,"",K) ).
	frontname( Str, F, R, Typ ) :-		/* $Lin Kind Addr Label Labe2 */
		frontchar( Str,'$',Str1 ),
		fronttoken( Str1,F,Str2 ),
		fronttoken( Str2,Kind,Str3 ),
		str_int( Kind,6 ), !, Typ=2,
		fronttoken( Str3,Address,Str4 ),
		frontlabel( Str4,Label,Str5 ),
		frontlabel( Str5,Label2,R),
		str_int( F,Lin ), str_int( Address,Addr ),
		asserta( l(Lin,Addr,Label,Label2,6) ).
	frontname( Str, Label, R, Typ ) :-	/* %Label Addr */
		frontchar( Str,'%',Str1 ),
		frontlabel( Str1,Label,Str2 ),
		fronttoken( Str2,R,_ ), !, Typ=3,
		str_int( R,Addr ),
		assertz( lbl(Label,Addr) ).
	frontname( Str, F, R, Typ ) :-		/* FILLER (FIL$xxxx) */
		fronttoken( Str, F1, R1 ),
		frontchar( R1, '$', _ ),!,
		fronttoken( R1, FF1, RR1 ),
		fronttoken( RR1, FF2, R ),
		concat( F1,FF1,F2 ), concat( F2,FF2,F ),Typ=0.
	frontname( Str, F, R, Typ ) :-		/* Variable */
		fronttoken( Str, F, R ),Typ=1.

	readsymbol( Line ) :-
		frontname(Line,Name,Rest,Typ),Typ=1,
		fronttoken(Rest,O,Rest1), str_int(O,Off),
		fronttoken(Rest1,W,Rest2),
		fronttoken(Rest2,T,_),
		str_int(W,Wid), str_int(T,TabL),
		assert(v(Name,Off,Wid,TabL,'X')),
		/*shiftwindow(OLD),shiftwindow(1),
		write("\n",Name," -> ",Off,",",Wid),
		shiftwindow(OLD),*/ !.
	readsymbol( Line ) :-
		frontname(Line,Name,Rest,Typ),Typ=1,
		fronttoken(Rest,"C",Rest0),
		fronttoken(Rest0,O,Rest1),fronttoken(Rest1,W,Rest2),
		fronttoken(Rest2,T,_),
		str_int(O,Off), str_int(W,Wid), str_int(T,TabL),
		assert(v(Name,Off,Wid,TabL,'C')),
		/*shiftwindow(OLD),shiftwindow(1),
		write("\n",Name," -> ",Off,",",Wid),
		shiftwindow(OLD),*/ !.
	readsymbol( _ ).

	save_string( _,_,_,0 ) :- !.
	save_string( Str,Seg,Off,Len ) :-
		frontchar( Str,Byte,Str1 ),
		membyte( Seg,Off,Byte ), Len1 = Len-1, Off1 = Off+1,
		!, save_string( Str1,Seg,Off1,Len1 ).
	
	check_installed :-
		bios($2f,reg($ef00,0,0,0,0,0,0,0),
			reg(AX,_,_,_,_,_,_,_)),
		bitand(AX,$ff,AL), AL<>0,
		bios($2f,reg($ef04,0,0,0,0,0,0,0),
			reg(_,_,_,_,SyslistOff,_,SyslistSeg,_)),
		retractall( syslist(_,_) ), 
		assert( syslist( SyslistSeg,SyslistOff ) ), !.
	check_installed :-
		makewindow(3,9,32,"ERRO FATAL",12,20,4,37),
		write("Programa residente no instalado!!!"),
		write("No  possvel rodar o MCDebug"),
		readchar(_), removewindow, fail.
		
	check_used_terminal( Term ) :-
		syslist( SyS,SyO ),
		InitOffset = SyO + 24,
		InitSegment = SyO + 26,
		memword( SyS,InitOffset,TblOff ),
		memword( SyS,InitSegment,TblSeg ),
		FuncOff = TblOff + Term * 16, FuncOff1 = FuncOff + 2,
		memword( TblSeg,FuncOff1,Func ), Func<>0, !.
	
	calc_base_addr( Seg,Off0 ) :-
		term_process(TP),
		check_used_terminal( TP ),
		Off = Off0 + TP * 35, /* 31 */
		Off_bp = Off + 33, /* 29 */
		Off_ss = Off + 21, /* 7 */
		memword(Seg,Off_ss,J_ss),memword(Seg,Off_bp,BP),
		BP1=BP-2, retractall(varBase(_,_)),
		assert(varBase(J_ss,BP1)), !.
	calc_base_addr( Seg,Off ) :-
		makewindow(3,9,32,"*** ERRO ***",5,20,3,50),
		write("Terminal no inicializado no programa!"),
		readchar(_), removewindow,
		escolhe_terminal( 0 ), !, calc_base_addr( Seg,Off ).

	read_symb_table(DebugF) :-
		syslist( SyslistSeg,SyslistOff ),
		TaskOffset = SyslistOff + 28,
		TaskSegment = SyslistOff + 30,
		memword( SyslistSeg,TaskOffset,TermOff ),
		memword( SyslistSeg,TaskSegment,TermSeg ),
		calc_base_addr(TermSeg,TermOff),
		retract( proc_ptr(_,_) ), assert( proc_ptr(TermSeg,TermOff) ),
		openread(arquivo,DebugF),
		readdevice(OldDevice), readdevice(arquivo),
		repeat,
		readln(Line),
		readsymbol(Line),
		eof(arquivo),!,
		readdevice(OldDevice), closefile(arquivo).
		
	list_variables:-
		v(Sy,Off,Wid,TabL,_),
		write("\n",Sy," -> ",Off,",",Wid,",",TabL),
		fail.
	list_variables.
	
	select_var( Name ) :-
		select_var_base( SymName ),
		select_var_index( SymName, Name ), !.
		
	select_var_index( Name,Name ) :-
		v( Name,_,_,0,_ ), !.
	select_var_index( SymName,Name ) :-
		v( SymName,_,_,_,_ ),
		lineinput( 8,40,20,$9,$13,"Indice: ","",Num ),
		str_int( Num,N ), !,  /* testa se e' inteiro valido */
		N1 = N-1,
		str_int( Num1,N1 ),  /* corrige p/indice de 1 em diante */
		concat( SymName," ",S1 ), concat( S1,Num1,Name ).
	
	select_var_base( SymName ):-
		/*findall(N,v(N,_,_,_),Vars),*/
		vars(Vars),
		var_selected( Last ),
		longmenu(4,55,12,43,43,Vars,"Variveis",Last,Sel),
		Sel1=Sel-1,
		retract(var_selected(_)),assert(var_selected(Sel)),
		index( Sel1,Vars,SymName ),!.
	
	modify( SymName ) :-
		address_var( SymName,Seg,Off,Wid ),
		ptr_dword( S,Seg,Off ),
		frontstr( Wid,S,Field,_ ),
		lineinput( 8,10,65,$9,$13,"Modifica: ",Field,NewS ), !,
		save_string( NewS,Seg,Off,Wid ).
		
	display_var_list( List ) :-
		makewindow( _,_,_,_,_,_,H,W ),
		HH = H - 2, WW = W - 2,
		display_var_list( List,HH,WW ).
		
	display_var_list( _,0,_ ) :- !.
	display_var_list( [],H,W ) :- 
		H1=H-1, field_str( H1,0,W,"" ),
		!, display_var_list( [],H1,W ).
	display_var_list( [SymName|Rest],H,W ) :-
		display_var_name( SymName,S1 ),
		display_var( SymName,S2 ),
		concat( S1,"[",SS1 ), concat( SS1,S2,SS2 ),
		concat( SS2,"]",S3 ),
		H1 = H - 1,
		field_str( H1,0,W,S3 ),
		!, display_var_list( Rest,H1,W ).

	display_var_name( SymName,S ) :-
		fronttoken( SymName,Name,Rest ), str_int( Rest,Index ),
		Index1 = Index + 1,
		format( S,"%s(%d) = ",Name,Index1 ), !.
	display_var_name( SymName,S ) :-
		format( S,"%s = ",SymName ), !.

	display_var( Name,S ) :-
		fronttoken( Name,SymName,Rest ),
		v( SymName,Off,Wid,TabL,'X' ), 
		str_int(Rest,I), !,
		varBase( SS,BP ),
		Off1 = TabL * I,
		Off2 = BP - Off + Off1,
		cget_string( SS,Off2,Wid,S ), !.
	display_var( Name,S ) :-
		v( Name,Off,Wid,_,'X' ),
		varBase( SS,BP ),
		Off1 = BP - Off, 
		cget_string( SS,Off1,Wid,S ), !.
	display_var( Name,S ) :-
		fronttoken( Name,SymName,Rest ),
		v( SymName,Off,Wid,TabL,'C' ), 
		str_int(Rest,I), !,
		varBase( SS,BP ),
		Off1 = TabL * I,
		Off2 = BP - Off + Off1,
		cget_string1( SS,Off2,Wid,S ), !.
	display_var( Name,S ) :-
		v( Name,Off,Wid,_,'C' ),
		varBase( SS,BP ),
		Off1 = BP - Off, 
		cget_string1( SS,Off1,Wid,S ), !.
		
	address_var( Name,Segment,Offset,Width ) :-
		fronttoken( Name,SymName,Rest ),
		v( SymName,Off,Width,TabL,_ ),
		str_int(Rest,I), !,
		varbase( Segment,BP ),
		Off1 = TabL * I,
		Offset = BP - Off + Off1.
	address_var( Name,Segment,Offset,Width ) :-
		v( Name,Off,Width,_,_ ), !,
		varbase( Segment,BP ),
		Offset = BP - Off.
			
	conv_index( [],[] ) :- !.
	conv_index( [SymName|Rest],[NameC|Rest1] ) :-
		fronttoken( SymName,Name,Idx ),
		str_int( Idx,N ), N1=N+1, str_int( Idx1,N1 ),
		concat( Name,"(",Name1 ), concat( Name1,Idx1,Name2 ),
		concat( Name2,")",NameC),
		!, conv_index( Rest,Rest1 ).
	conv_index( [Name|Rest],[Name|Rest1] ) :-
		!, conv_index( Rest,Rest1 ).

	console :-
		repeat,
		bios($16,reg(0,0,0,0,0,0,0,0),reg(WCh,_,_,_,_,_,_,_)),
		key_map(WCh,Ch),
		console_send(Ch),
		Ch = $1b, !.

	console_send( $1b ) :- !.
	console_send( Ch )  :-
		bios( $2f,reg($ef10,0,0,Ch,0,0,0,0),_ ), !.
		
	key_map(WCh,Ch) :- 
		bitand(WCh,$ff,Ch1),
		Ch1 = 0,
		bitright(WCh,8,Ch2),
		scan_map(Ch2,Ch),!.
	key_map(WCh,Ch) :-
		bitand(WCh,$ff,Ch).
	
	scan_map(45,$1b).
	scan_map(83,$7f).

	get_cursor(Y,X) :-
		bios($10,reg($0f00,0,0,0,0,0,0,0),reg(_,BX,_,_,_,_,_,_)),
		bios($10,reg($0300,BX,0,0,0,0,0,0),reg(_,_,_,Cur,_,_,_,_)),
		bitand(Cur,$ff,X), bitright(Cur,8,Y), !.

