/*
**	Rotinas auxiliares do Sistema de Custos de Transportadoras
**
**	Rildo Pragana -- 11/18/90
*/

#include <stdio.h>
#include <bios.h>
#include <dos.h>
#include <mem.h>

void *malloc(unsigned size);
void *free(void *);
void *alloc_gstack(unsigned);

unsigned char fmtmap[512];

void tstdsk( int trk, int *res ) /* testa disco A e devolve resultado */
{
	int n,sector;
	for (sector=1;sector<=9;sector++) {
		_memset(fmtmap,0xff,512);
		_biosdisk(3,0,0,trk,sector,1,fmtmap);
		*res=_biosdisk(2,0,0,trk,sector,1,fmtmap);
		if (*res) {
			*res=sector*512;
			for (n=0;n<512;n++) {
				if (fmtmap[n]!=0xff) {
					*res+=n;
					break;
				}
			}
			break;
		}
	}
}

/*
** rotina para confirmacao do disco
**  t1, t2 = trilhas seguramente boas
**  t, s   = trilha/setor com defeito
**  res    = 0 se teste OK
*/
void tdsk_0(int t1, int t2, int t, int s, int *res)
{
	int r,tent;
	unsigned v;
	v=FP_SEG(_getvect(0x13));
	if ((v>0x300)&&(v<0xa000)) {
		*res=1;
		return;
	}
	_biosdisk(0,0,0,0,1,1,fmtmap);
	_biosdisk(2,0,0,0,1,1,fmtmap);
	for (tent=0;tent<3;tent++)  {
		tstdsk(t1,&r);
		if (!r) { *res=0; break; }
	}
	for (tent=0;tent<3;tent++)  {
		tstdsk(t2,&r);
		if (!r) { *res=0; break; }
	}
	for (tent=0;tent<3;tent++)  {
		tstdsk(t,&r);
		if (_abs(r-s)<10) { *res=0; return; }
	}
	*res=1;
}
