#include <dos.h>
#include <conio.h>

#define	DATA_PORT	0x300
#define	COMM_PORT	0x301

#define INTMASK		0x21

#define	RD_KBD		0
#define	WR_DSP_DAT	1
#define WR_DSP_COM	2
#define	RD_STA		3
#define WR_LED		4
#define	WR_ADD		5
#define	WR_PRT		6

#define	BUSY		1
#define TMO		2

int intreq = 0;
int tmoln = 0;
int tmocnt=0;
int tabn;
int bdir;
unsigned char	Address=0x1e;
char codigo[25] = "-----------------";
char icod;
char code7;
char bins[20];
char *binptr=bins;

char bcodea[] = {0x0d,0x19,0x13,0x3d,0x23,0x31,0x2f,0x3b,0x37,0x0b};
char bcodeb[] = {0x27,0x33,0x1b,0x21,0x1d,0x39,0x05,0x11,0x09,0x17};
char bcodec[] = {0x39,0x33,0x1b,0x21,0x17,0x27,0x05,0x11,0x09,0x1d};
char bcodei[] = {0x0b,0x13,0x19,0x2f,0x31,0x23,0x3d,0x37,0x3b,0x0d};
char bcode7[] = {0x00,0x0b,0x0d,0x0e,0x13,0x19,0x1c,0x15,0x16,0x1a};

int validate_code() {
	int i;
	for (i=0;i<14;i++)
		if (codigo[i]==0) return 0;
	for (i=0;i<10;i++) {
		if (code7 == bcode7[i]) 
			return (i+'0');
	}
	return 0;
}

void bdecode( int i ) {
	int x,c;
	char *tab;
	c = 0;
	/*switch(tabn) {
	case 1:
	case 3:
	case 5:
		tab = bcodea;
		break;
	case 2:
	case 4:
	case 6:
		tab = bcodeb;
		break;
	case 7:
	case 14:
		if (i==5)
			codigo[icod++] = '*';
		return;
	default:
		tab = bcodec;
		break;
	}*/
	if ((tabn==7) || (tabn==14)) {
		if (i==5)
			codigo[icod++] = '*';
		return;
	}
	if (tabn==1) bdir=0; /* suponha direcao normal */
	for (x=0;x<10;x++) {
		/*if (i==*(tab+x)) { c=x+'0'; break; }*/
		if (tabn==1)
		{
			if (i==*(bcodea+x)) { 
				c=x+'0'; 
				bdir=0; 
				break;
			}
			if (i==*(bcodeb+x)) { 
				c=x+'0'; 
				bdir=1; 
				break;
			}
		}
		else {
			if ( ((tabn<7) && !bdir) ||
			     ((tabn>7) && bdir) ) 
			{
				if (i==*((bdir ? bcodec : bcodeb)+x)) { 
					c=x+'0'; 
					code7 |= (0x40 >>
						(bdir ? 14-tabn : tabn));
					break;
				}
				if (i==*((bdir ? bcodei : bcodea)+x)) { 
					c=x+'0'; 
					break;
				}
			}
			else
				if (i==*((bdir ? bcodeb : bcodec)+x)) { 
					c=x+'0'; 
				break; 
			}
		}
	}
	/*printf("%c",c);*/
	codigo[icod++] = c;
}

unsigned char	time_out()
{
	unsigned char	status;
	int i;

	for (i=0;i<20000;i++) 
		if (intreq) break;
	intreq = 0;
/*	do {*/
		status = inportb( COMM_PORT );
/*	} while( status & BUSY );*/
	return( status & TMO );
}

int read_address() {
	Address = inportb( COMM_PORT ) >> 3;
}

int read_byte()
{
	unsigned char	byte,status;

	byte = inportb( DATA_PORT );
	status = inportb( COMM_PORT );
	if (status & TMO)
		return( -1 );
	return( byte );
}

void	send_byte(unsigned int port, unsigned char byte)
{
	/*time_out();*/
	outportb( port, byte );
}

void	send_comm(unsigned char command)
{
	int i,c;
	unsigned char	byte;

	byte = Address << 3 | command;
	send_byte( COMM_PORT, byte );
	if (time_out() != TMO)
		tmoln=0;
	if (tmoln) {
		if (++tmocnt > 100) {
			tmocnt = 0;
			tmoln = 0;

			tabn = 1;
			icod = 0;
			code7 = 0;
			
			for (i=0;i<14;i++) {
				codigo[i]=0;
				bdecode(bins[i]);
				tabn++;
			}
			if (c=validate_code()) {
				printf("%c ",c);
				if (bdir) { 
					for (i=12;i>=0;i--)
						printf("%c",codigo[i]);
				}
				else {
					for (i=0;i<13;i++)
						printf("%c",codigo[i]);
				}
				if (bdir)
					printf("<");
				else
					printf(">");
			}
			else {
				printf("\n** INVALIDO **");
				/* imprime tabela em binario */
				/*printf("\nTab: ");
				for (i=0;i<13;i++) {
					printf("%02x ",bins[i]);
				}
				printf(" <%02x>",code7);*/
			}
			printf("\n==>");
			binptr = bins;
		}
	}
}

void interrupt (*Int0fsv)();

void interrupt Int0f() {
	intreq++;
	outportb( 0x20,0x20 );
}

void	main()
{
	int i,k=0;

	/* prepara vetor de interrupcao 0x0f */
	disable();
	Int0fsv = getvect(0x0f);
	setvect(0x0f,Int0f);
	outportb( INTMASK,inportb( INTMASK ) & 0x7f );
	send_comm( RD_KBD );
	enable();

	k=0;
	while( !kbhit() ) {
		send_comm( RD_KBD );
		i=read_byte();
		if ((i!=-1) /*&& (i!=0)*/) {
			read_address();
			send_byte( DATA_PORT, i^0xff );
			send_comm( WR_LED );
			if ((i&0xc0)==0x80) {
				printf("\n[%02X] --> %c %1X - ",Address,
					(i&0x10) ? 'B' : 'M', i&0xf);
			}
			else if ((i&0x80) == 0) {
				tmoln=1;
				/*tabn++;*/
				*binptr++ = i; /* processa depois */
				/*bdecode(i);*/
				/*printf("%02X ",i);*/
			}
		}
	}
	setvect(0x0f,Int0fsv);
}