;
;	Programa Residente para acesso aos Microterminais
;	Modulo Driver de Interrupcoes
;	Rildo Pragana -- 07/07/93
;

DOSSW_TEXT	segment	byte public 'CODE'
DGROUP	group	_DATA,_BSS
	assume	cs:DOSSW_TEXT,ds:DGROUP,ss:DGROUP
DOSSW_TEXT	ends

extrn	__signal:far,_wait:far,_scheduler:far
extrn	_process_event:far,_process_lpen:far
;extrn	_get_key:far
extrn	_check_ready:far
extrn  	_signal_timer:far
extrn	_mtnet_uninstall:far
extrn	_put_sysch:far
_DATA	segment word public 'DATA'
d@	label	byte
d@w	label	word
_DATA	ends

_VIDEO_SEG segment byte public at 0B800h 'VIDEO_SEG'
_VIDEO_SEG ends

extrn	_binptr:byte
extrn	_msg_blk_size:word,_terminais:far
;extrn	_ftimer:byte
;extrn	_timer_data:word
extrn   _polling:byte,_sdsp:far,_sprt:far,_semaf_size:word
extrn	_syslist:far
extrn	__psp:word,__atopsp:word,_end:word,__abrktb:word

_BSS	segment word public 'BSS'
b@	label	byte
b@w	label	word
_BSS	ends

;TESTVER	equ	1	; comentar para versao de uso normal

MAXFILA	equ	64

eoff	equ	3
soff	equ	4
peoff	equ	5
psoff	equ	6
fila	equ	7

_DATA	segment word public 'DATA'
;public  _criptword
_criptword      dw      0       ; pedido de verificacao de senha
;public  _criptres
_criptres       dw      0       ; resultado de verificacao de senha
        public _dummy_semaf
        public  _usrptr
dummy_rdy      db      1
_dummy_semaf   dw      0
               dd      0
_usrptr        dw      0,0
in_lpen        db      0
        public _prtfila
_prtfila        db      2048 dup (?)   ; fila de impressora (64 ch/term)
public  _htmem
_htmem		dw	?
dispdt		db	?
_fatortimer	db	1
lastcmd		db	1		  ; 1 = polling
_inRefresh	db	0ffh
rtty		db	0		  ; term # for refresh
rnumb		db	?		  ; no of term without chars
rsdsp		dw	offset _sdsp	  ; disp semaf for refresh
rsprt           dw      offset _sprt
rtermp          dw      offset _terminais ; term struct pointer for refresh
_mdisp	db	?
sdsp	dw	?
count	dw	?
tty	dw	?
_DATA	ends

DOSSW_TEXT	segment	byte public 'CODE'
assume	ds:DGROUP,cs:DOSSW_TEXT,ss:DGROUP

PUBLIC	_htalloc,_htallocinit
PUBLIC	_keep_pgm
PUBLIC	_desinstala

PUSHR	MACRO	Rlist
	IRP	R,<Rlist>
	push	R
	ENDM
	ENDM

POPR	MACRO	Rlist
	IRP	R,<Rlist>
	pop	R
	ENDM
	ENDM

SAVSTK	MACRO	N
	mov	word ptr cs:ax_sav&N,ax
	mov	word ptr cs:sp_sav&N,sp
	mov	ax,ss
	mov	word ptr cs:ss_sav&N,ax
	mov	ax,DOSSW_TEXT
	mov	ss,ax
	lea	sp,locstk&N
	mov	ax,word ptr cs:ax_sav&N
	ENDM

RESSTK	MACRO	N
	mov	word ptr cs:ax_sav&N,ax
	mov	sp,word ptr cs:sp_sav&N
	mov	ax,word ptr cs:ss_sav&N
	mov	ss,ax
	mov	ax,word ptr cs:ax_sav&N
	ENDM

INSTALLINT	MACRO	Inum,IFun,OldVect
	mov	di,(Inum*4)		; instala Int<Inum>
	mov	ax,word ptr es:[di]
	mov	cs:OldVect,ax
	mov	ax,word ptr es:[di+2]
	mov	cs:OldVect+2,ax
	lea	ax,IFun
	mov	word ptr es:[di],ax
	mov	ax,DOSSW_TEXT
	mov	word ptr es:[di+2],ax
	ENDM

UNINSTALL	MACRO	Inum,OldVect
	mov	di,(Inum*4)
	mov	ax,cs:OldVect
	mov	word ptr es:[di],ax
	mov	ax,cs:OldVect+2
	mov	word ptr es:[di+2],ax
	ENDM

INSTALLINTV      MACRO   Inum,IFun,OldVect
        mov     di,word ptr Inum             ; instala Int<Inum>
        shl     di,1
        shl     di,1
	mov	ax,word ptr es:[di]
	mov	cs:OldVect,ax
	mov	ax,word ptr es:[di+2]
	mov	cs:OldVect+2,ax
	lea	ax,IFun
	mov	word ptr es:[di],ax
	mov	ax,DOSSW_TEXT
	mov	word ptr es:[di+2],ax
	ENDM

UNINSTALLV       MACRO   Inum,OldVect
        mov     di,word ptr Inum
        shl     di,1
        shl     di,1
	mov	ax,cs:OldVect
	mov	word ptr es:[di],ax
	mov	ax,cs:OldVect+2
	mov	word ptr es:[di+2],ax
        ENDM

eoi59   equ     020h
in_sched        db      0       ; sera' decrementado (0ffh) na inicializacao

signature:
        db      'HTDRVPARMS'
ifdef IRQINST
imr     dw     0a1h            ; 21h p/8259 #1 (IRQ7), 0a1h p/8259 #2 (IRQ2)
imask   db     02h             ; 80h (IRQ7) or 02h (IRQ2/IRQ9)
nmask   db     0fdh            ; 7fh (IRQ7) or 0fdh (IRQ2/IRQ9)
Ivect   db     0ah             ; 0fh (IRQ7) or 0ah (IRQ2)
else
imr     dw     021h
imask   db     80h             ; 80h (IRQ7) or 02h (IRQ2/IRQ9)
nmask   db     07fh            ; 7fh (IRQ7) or 0fdh (IRQ2/IRQ9)
Ivect   db     0fh             ; 0fh (IRQ7) or 0ah (IRQ2)
endif
lasttty         db      0
fatorini        db      2       ; numero de ticks entre refreshs
dataport        dw      300h
cmdport         dw      301h

;       dw      400h dup (?)
;locstk1	dw	?
;sp_sav1	dw	?
;ss_sav1	dw	?
;ax_sav1	dw	?
	dw	400h dup (?)
locstk2	dw	?
sp_sav2	dw	?
ss_sav2	dw	?
ax_sav2	dw	?
	dw	400h dup (?)
locstk3	dw	?
sp_sav3	dw	?
ss_sav3	dw	?
ax_sav3	dw	?

schedft		dw	10
sch_ticks	dw	10

IFDEF	TESTVER
video_sav	dw	5 dup (?)
ENDIF

        public  _intdebug
_intdebug       proc far
        int     05
        ret
_intdebug       endp

_htallocinit    proc    far
	push	bp
	mov	bp,sp
;	mov	ax,__atopsp	; topo da pilha (livre)
;	mov	ax,_end
	mov	ax,word ptr __abrktb
	mov	cl,4
	shr	ax,cl
	inc	ax
;	add	ax,__psp
	add	ax,DGROUP
	add	ax,80h		; paragrafos para a pilha (main)
	mov	_htmem,ax
	pop	bp
	ret
_htallocinit	endp

_htalloc	proc	far
	arg	parsize:word
	push	bp
	mov	bp,sp
	mov	ax,_htmem	; reserva memoria em paragrafos
	add	ax,[parsize]
	mov	_htmem,ax
	mov	dx,ax		; retorna ptr
	xor	ax,ax
	pop	bp
	ret
_htalloc	endp

_entry21	proc	near
	PUSHR	<ax,cx,es,ds,di,si>
	cld
	mov	ax,cs
	mov	es,ax
	assume	es:DOSSW_TEXT
	lea	di,DosArea		; ES:DI --> &DosArea
	lds	si,dword ptr cs:[DosVPnt]       ; DS:SI --> DosVPnt
	mov	cx,word ptr cs:dosswcnt         ; CX    --> dosswcnt
	shr	cx,1
	rep	movsw
	mov	ax,cs
	mov	ds,ax
	assume	ds:DOSSW_TEXT
	lea	si,LocArea
	les	di,dword ptr cs:[DosVPnt]
	mov	cx,word ptr cs:dosswcnt
	shr	cx,1
	rep	movsw
	xor	ax,ax		; endereca segmento de vetores de intr
	mov	es,ax
	INSTALLINT	23h,_Int23,Int23Word
	INSTALLINT	24h,_Int24,Int24Word
IFDEF	TESTVER
	; ****** Mostra acesso em background no video
	mov	ax,0b800h
	mov	ds,ax
	assume	ds:VIDEO_SEG
	mov	si,0
	mov	ax,ds:[si]
	mov	word ptr video_sav,ax
	mov	ax,0f57h
	mov	ds:[si],ax
	; ******
ENDIF
	POPR	<si,di,ds,es,cx,ax>
	ret
_entry21	endp

_exit21	proc	near
	PUSHR	<ax,cx,es,ds,di,si>
	cld
	mov	ax,cs
	mov	es,ax
	assume	es:DOSSW_TEXT
	lea	di,LocArea
	lds	si,dword ptr cs:[DosVPnt]
	assume	ds:DOSSW_TEXT
	mov	cx,word ptr cs:dosswcnt
	shr	cx,1
	rep	movsw
	mov	ax,cs
	mov	ds,ax
	assume	ds:DOSSW_TEXT
	lea	si,DosArea               ; DS:SI --> &DosArea
	les	di,dword ptr cs:[DosVPnt]	; ES:DI --> DosVPnt
	mov	cx,word ptr cs:dosswcnt		; CX    --> dosswcnt
	shr	cx,1
	rep	movsw
	xor	ax,ax		; endereca segmento de vetores de intr
	mov	es,ax
	UNINSTALL	23h,Int23Word
	UNINSTALL	24h,Int24Word
IFDEF	TESTVER
	; ****** Mostra acesso em background no video
	mov	ax,0b800h
	mov	ds,ax
	assume	ds:VIDEO_SEG
	mov	si,0
	mov	ax,word ptr video_sav
	mov	ds:[si],ax
	; ******
ENDIF
	POPR	<si,di,ds,es,cx,ax>
	ret
_exit21	endp

busyflgs        db      32 dup (0)
_rdKeyb db      0
_in_disk	db	0
dosPSP		dw	?
locPSP		dw	?
dosswcnt	dw	?
swcnth		dw	?
swcntl		dw	?
DosVWord	label	word
DosVPnt         dd	?
DosArea		db	800h dup (?)
LocArea		db	800h dup (?)

InstErrMsg	db	0dh,0ah,'Erro fatal na instalacao',0dh,0ah
		db	'Informe a HandTerm!$'

_keep_pgm	proc	far
	arg	paragraphs:word,ticks:word
	push	bp
	mov	bp,sp
	push	bp
	mov	ah,62h
	int	21h
	mov	word ptr cs:locPSP,bx
	mov	ax,5d06h	; get msdos areas
	Int	21h
	mov	word ptr cs:dosswcnt,cx
	mov	word ptr cs:swcnth,cx
	mov	word ptr cs:swcntl,dx
	mov	word ptr cs:DosVWord,si
	mov	word ptr cs:DosVWord+2,ds
	mov	ax,cs
	mov	es,ax
	lea	di,LocArea   ; save a copy of area2
	cld
	rep 	movsb
	lds	si,dword ptr cs:[DosVPnt]
	sub	si,0bh
	mov	al,50h	; 'push ax'
	cli
	mov	bx,word ptr ds:[si]
	mov	byte ptr ds:[bx],al
	mov	bx,word ptr ds:[si+2]
	mov	byte ptr ds:[bx],al
	mov	bx,word ptr ds:[si+4]
	mov	byte ptr ds:[bx],al
	mov	bx,word ptr ds:[si+6]
	mov	byte ptr ds:[bx],al
	pop	bp
	mov	ax,DGROUP
	mov	ds,ax
	xor	ax,ax		; endereca segmento 0 (vetores)
	mov	es,ax
	INSTALLINT	13h,_Int13,Int13Word
	INSTALLINT	2fh,_Int2f,Int2fWord
	INSTALLINT	2ah,_Int2a,Int2aWord
	INSTALLINT	28h,_Int28,Int28Word
	INSTALLINT	08h,_Int08,Int08Word
        INSTALLINTV     cs:Ivect,_Int0f,Int0fWord
;
        mov     dx,word ptr cs:imr       ; habilita interrupt (IRQ7 or IRQ9)
        in      al,dx
        and     al,cs:nmask        ; mask for IRQ9 or IRQ7
        out     dx,al
;
	xor	al,al
        mov     dx,cs:cmdport
	out	dx,al
;
	mov	dx,[ticks]
	mov	word ptr cs:sch_ticks,dx
	dec	cs:in_sched		; ativa o scheduler
	dec	byte ptr _polling	; ativa o polling
	mov	dx,[paragraphs]
	mov	ax,3100h
	int	21h
	mov	ax,0900h   		; para o caso de retorno (erro?)
	lds	dx,dword ptr cs:[InstErrMsg]
	int	21h
	cli
	hlt
_keep_pgm	endp

_desinstala	proc	far
	pushf
	cli
	push	ax
	push	es
	push	di
	xor	ax,ax
	mov	es,ax
;
        push    dx
        mov     dx,word ptr cs:imr
	in	al,dx
        or      al,cs:imask
	out	dx,al
        pop     dx
;
        UNINSTALLV      cs:Ivect,Int0fWord
	UNINSTALL	08h,Int08Word
	UNINSTALL	2ah,Int2aWord
	UNINSTALL	2fh,Int2fWord
	UNINSTALL	28h,Int28Word
	UNINSTALL	13h,Int13Word
	pop	di
	pop	es
	pop	ax
	popf
	ret
_desinstala	endp

;
;	******************     D R I V E R S     *********************
;

Int08Word 	label word
_Old_Int08	dd	?	; variavel no segmento de codigo

_Int08  proc    far
I08a:	PUSHR	<ds,ax>
	mov	ax,DGROUP
	mov	ds,ax
	assume	ds:DGROUP
	pushf
	call	dword ptr cs:[_Old_Int08]
;
; ======= verifica se existe algum display necessitando servico
;
	test	_mdisp,0ffh	; ja' marcado p/atualizacao?
	jnz	I08norm
	push	si
	push	cx
	xor	cl,cl
	mov	si,offset _terminais
mdchk:
	mov	al,[si+eoff]	; compara entrada=saida
	sub	al,[si+soff]
	jz      mdledchk
	inc	_mdisp
	pop	cx
	pop	si
	jmp	I08norm
mdledchk:
	test	byte ptr [si+2],80h
        jz      mdprtchk
	inc	_mdisp
	pop	cx
	pop	si
	jmp	I08norm
mdprtchk:
        mov     al,[si+peoff]
        sub     al,[si+psoff]
        jz      mdprox
        inc     _mdisp
        pop     cx
        pop     si
        jmp     I08norm
mdprox:
	add	si,_msg_blk_size
	inc	cl
	cmp	cl,32
	jnz	mdchk
	pop	cx
	pop	si
; ****************** teste
;       jmp     I08b
;
I08norm:
; ****************** teste
       jmp     I08b
;       SAVSTK  1
;	sti
;	PUSHR	<bx,cx,dx,si,di,es,bp>
;	call	far ptr _signal_timer
;	POPR	<bp,es,di,si,dx,cx,bx>
;	RESSTK	1
I08y:   sti
	inc	cs:in_sched
	jz	I08w
	jmp	I08h
I08w:	SAVSTK	3
	PUSHR	<bx,cx,dx,si,di,es,bp>
	mov	ax,DGROUP
	mov	ds,ax
	assume	ds:DGROUP
	call	far ptr _signal_timer
	call	far ptr _check_ready
	test	ax,0ffh
	jz      I08g
	test	word ptr cs:CritSect,0ffffh
	jnz	I08g
	test	byte ptr cs:_in_disk,0ffh
	jnz	I08g
	lds	si,dword ptr cs:[DosVPnt]
	mov	ax,word ptr ds:[si]
	or	ah,al
	mov	ax,word ptr cs:swcntl
	jz	I08j
	mov	ax,word ptr cs:swcnth
I08j:	mov	word ptr cs:dosswcnt,ax
	call	near ptr _entry21
	mov	ax,DGROUP
	mov	ds,ax
	assume	ds:DGROUP
	call	far ptr _scheduler
	call	near ptr _exit21
I08g:	POPR	<bp,es,di,si,dx,cx,bx>
	RESSTK	3
I08h:   dec	cs:in_sched
I08b:	pop	ax
	pop	ds
	iret
_Int08  endp

Int0fWord       label word
_Old_Int0f	dd	?	; variavel no segmento de codigo

_refresh        proc    near
	jc	nextdisp		; inicializa refresh?
	test	_mdisp,0ffh
	jnz	rfshinit
	stc
	jmp	itend
rfshinit:
	mov	rtty,0			; contador de terminais
	mov	rnumb,0
	lea	ax,_sdsp
	mov	rsdsp,ax 		; ponteiro p/os semaforos
        lea     ax,_sprt
        mov     rsprt,ax
        lea     ax,_terminais
	mov	rtermp,ax		; pont. p/estruturas (array)
nextdisp:
	cmp	rtty,32			; last tty?
	jne	itsend
	cmp	rnumb,32
	jnz     scanok
	mov	_mdisp,0
scanok:
	stc				; return error
	jmp     itend
itsend:
	push	si
	mov	si,rtermp
;
; ====> refresh led indicators
;
itleds:
	test	byte ptr [si+2],80h
        jz      it3
	xor	byte ptr [si+2],80h
	mov	al,byte ptr [si+2]
	xor	al,0ffh
        mov     dx,cs:dataport
	out	dx,al
	mov	al,rtty		; endereco do terminal
	shl	al,1
	shl	al,1
	shl	al,1
	or	al,4		; combine comando WR_LEDS+endereco
	mov	byte ptr dispdt,al
	jmp	itcdn		; ******* TESTE
	mov	lastcmd,0
;	mov	_mdisp,0
	clc
	pop	si
	jmp	itend
;
it3:
        mov     al,[si+eoff]    ; compara entrada=saida
	sub	al,[si+soff]
	jnz	itenvia
        jmp     itprt           ; se vazio (buffer), skip
;
; <--------------- envia dados ao display ---------------------->
;
itenvia:
	PUSHR	<di,es,bx,cx,bp>
	mov	ax,si		; obtenha proximo caracter do buffer
	add	ax,fila
	add	al,[si+soff]
	adc	ah,0
	add	al,[si+soff]
	adc	ah,0
	mov	bx,ax
	mov	al,[bx]
	test	byte ptr [bx+1],1
	jnz	itcomm
itdata:			; envia dados ao display
        mov     dx,cs:dataport
	out	dx,al
	mov	al,rtty
	shl	al,1
	shl	al,1
	shl	al,1
	or	al,2	; comando send-display-data
;	inc	dx
;	out	dx,al
	mov	byte ptr dispdt,al
	jmp	itcd
itcomm:			; envia comando ao display
        mov     dx,cs:dataport
	out	dx,al
	mov	al,rtty
	shl	al,1
	shl	al,1
	shl	al,1
	or	al,1	; comando send-display-command
;	inc	dx
;	out	dx,al
	mov	byte ptr dispdt,al
itcd:
	mov	si,rtermp
	mov	al,byte ptr[si+soff]	; avanca o ponteiro de saida
	inc	al
	and	al,MAXFILA-1		; mascare o ponteiro p/evitar estouro
	mov	byte ptr[si+soff],al	; armazene-o de volta
	cmp	al,byte ptr [si+eoff]
	jne	itcd1			; sinaliza somente quando vazio
	push	ds
	mov	ax,rsdsp
	push 	ax
        call    far ptr __signal
	add	sp,4
itcd1:
	POPR	<bp,cx,bx,es,di>
;
; <------------------ dados enviados ao display ------------------->
;
itcdn:
	mov	ax,rtermp
	add	ax,_msg_blk_size	; proximo terminais[term] do array
	mov     rtermp,ax
	mov	ax,rsdsp
	add	ax,_semaf_size		; proximo semaforo do array
	mov	rsdsp,ax
        mov     ax,rsprt
        add     ax,_semaf_size
        mov     rsprt,ax
        inc     rtty                    ; avanca contador de terminais
        and     lastcmd,0feh            ; apaga flag de polling
	clc
	pop	si
	jmp	itend
;
itprt:                  ; ----->> testa status da impressora do terminal
        push    bx
        mov     bl,rtty
        xor     bh,bh
        add     bx,offset busyflgs
        test    byte ptr cs:[bx],0ffh
        pop     bx
        jz      itpsnd          ; se busy desligado, envie caracter
;                               ; ...senao leia status deste terminal
        mov     al,rtty         ; endereco do terminal p/ler status busy
        mov     cs:lasttty,al
        shl     al,1
        shl     al,1
        shl     al,1
        or      al,3            ; combine comando 'read status'
        mov     byte ptr dispdt,al
        or      lastcmd,2       ; liga flag 'status prt sent'
        jmp     itcdn
itpsnd:
        mov     al,[si+psoff]   ; verifica se algo no buffer
        cmp     al,[si+peoff]
        jnz     itprt1
        jmp     itempty
itprt1:
        PUSHR   <di,es,bx,cx,bp>
        mov     bl,rtty          ; liga 'busy prt' deste terminal
        xor     bh,bh
        add     bx,offset busyflgs
        or      byte ptr cs:[bx],1
        mov     bl,rtty         ; calcula endereco do buffer de printer
        xor     bh,bh
        mov     cl,6            ; multiplica por 64 (caracts no buffer)
        shl     bx,cl
        add     bx,offset DGROUP:_prtfila
        add     bl,[si+psoff]
        adc     bh,0
;
        assume  ds:DGROUP
        mov     al,[bx]
        mov     dx,cs:dataport
        ;               mov     al,40h ; ******** TESTE, RETIRAR *****
        out     dx,al
        mov     al,rtty
        shl     al,1
        shl     al,1
        shl     al,1
        or      al,6            ; comando send-prt-data
        mov     byte ptr dispdt,al
        mov     si,rtermp
        mov     al,byte ptr[si+psoff]    ; avanca o ponteiro de saida
        inc     al
        and     al,63                  ; mascare o ponteiro p/evitar estouro
        mov     byte ptr[si+psoff],al    ; armazene-o de volta
        cmp     al,byte ptr [si+peoff]
        jne     itprt2                   ; sinaliza somente quando vazio
; -- verifica se existem menos de 32 caracteres no buffer de impressora
;        sub     al,byte ptr [si+peoff]
;        jnc     itprt7
;        neg     al
;itprt7: cmp     al,32
;        ja      itprt2
; -- sinaliza processo p/preenchimento do buffer de impressao
        push    ds
        mov     ax,rsprt
        push    ax
        call    far ptr __signal
        add     sp,4
itprt2:
        POPR    <bp,cx,bx,es,di>
        jmp     itcdn
;
itempty:
	inc	rnumb
	mov	ax,rtermp
	add	ax,_msg_blk_size	; proximo terminais[term] do array
	mov     rtermp,ax
	mov	ax,rsdsp
	add	ax,_semaf_size		; proximo semaforo do array
	mov	rsdsp,ax
        mov     ax,rsprt
        add     ax,_semaf_size
        mov     rsprt,ax
        inc     rtty                    ; avanca contador de terminais
	pop	si
	jmp	nextdisp
itend:
	ret
_refresh	endp

_Int0f  proc    far
	PUSHR	<ds,ax,dx>
	mov	ax,DGROUP
	mov	ds,ax
	assume	ds:DGROUP
        inc     byte ptr _polling
        jz      I0finit
        jmp     I0ftt
I0finit:
	test	lastcmd,1	; last command was polling?
	jnz	I0fpoll
	jmp	I0fb
I0fpoll:
        mov     dx,cs:cmdport
	in	al,dx
	test	al,2		; time out?
	jnz	I0fa		; no key pending
	SAVSTK	2
	sti
	PUSHR	<bx,cx,si,di,bp,es>
	mov	bl,al
	shr	bl,1
	shr	bl,1
	shr	bl,1
	and	bl,1fh		; endereco do terminal
	dec	dx
	in	al,dx		; tecla
	test	al,80h
	jz	I0fperr		; erro de polling
	test	al,40h
	jnz	I0fperr
	mov	ah,al
	shr	al,1
	shr	al,1
	shr	al,1
	shr	al,1
	and	al,1
	xor	al,1
	and	ah,0fh
	push	ax
	push	bx
	call	far ptr _process_event
	add	sp,4
I0fperr:
	POPR	<es,bp,di,si,cx,bx>
	cli
	RESSTK	2
	jmp	I0ftt
I0fa:
	dec	byte ptr _fatortimer
	jz	I0fd
	jmp	I0ftt
I0fd:
        push    ax
        mov     al,byte ptr cs:fatorini
        mov     byte ptr _fatortimer,al
        pop     ax
        sti
	clc
	call	near ptr _refresh
	jc	I0ftt
	cli
	mov	al,dispdt
        mov     dx,cs:cmdport
	out	dx,al
	jmp	I0fend
I0fb:				; last command was not polling
        test    lastcmd,2       ; lastcmd was 'read prt status'?
        jnz     I0fstat
        jmp     I0fdisp
I0fstat:
        and     lastcmd,0fdh    ; clear prt status flag
        mov     dx,cs:dataport
        in      al,dx
        sti
        and     al,20h          ; test prt busy flag
        jnz     I0fdisp         ; nothing changed yet
        push    bx
        mov     bl,cs:lasttty
        xor     bh,bh
        add     bx,offset busyflgs
        mov     byte ptr cs:[bx],0
        pop     bx
I0fdisp:
        sti
	stc                     ; continue refresh
	call	near ptr _refresh
	jc	I0ftt
	cli
	mov	al,dispdt
        mov     dx,cs:cmdport
	out	dx,al
	jmp	I0fend
I0ftt:
; ---- check criptword request ----
        test     word ptr _criptword,0ffffh
        jz      I0ftt1
        mov     ax,word ptr _criptword
        mov     word ptr _criptword,0   ; no more requests
        mov     dx,cs:dataport
        out     dx,al
        inc     dx
        mov     cx,100
I0flp1: loop    I0flp1
        in      al,dx
        and     al,4
        jz      I0fcrer
        dec     dx
        mov     ah,al
        mov     cx,100
I0flp3: loop    I0flp3
        in      al,dx
        out     dx,al
        inc     dx
        mov     cx,100
I0flp2: loop    I0flp2
        in      al,dx
        and     al,4
        jz      I0fcrer
I0fcrok:
        mov     word ptr _criptres,1h
        jmp     I0ftt1
I0fcrer:
        mov     word ptr _criptres,0ffffh       ; error found
; ---------------------------------
I0ftt1: or      lastcmd,1       ; indicates polling sent
        mov     dx,cs:cmdport
	xor	al,al		; send a 'poll' command
	out	dx,al
I0fend:
        dec     byte ptr _polling
        mov     al,20h          ; EOI para o 8259
        out     eoi59,al
;
;
Z08y:   sti
	inc	cs:in_sched
        jz      Z08w
        jmp     Z08h
Z08w:   SAVSTK  3
	PUSHR	<bx,cx,dx,si,di,es,bp>
	mov	ax,DGROUP
	mov	ds,ax
	assume	ds:DGROUP
	call	far ptr _signal_timer
	call	far ptr _check_ready
	test	ax,0ffh
        jz      Z08g
	test	word ptr cs:CritSect,0ffffh
        jnz     Z08g
	test	byte ptr cs:_in_disk,0ffh
        jnz     Z08g
	lds	si,dword ptr cs:[DosVPnt]
	mov	ax,word ptr ds:[si]
	or	ah,al
	mov	ax,word ptr cs:swcntl
        jz      Z08j
	mov	ax,word ptr cs:swcnth
Z08j:   mov     word ptr cs:dosswcnt,ax
	call	near ptr _entry21
	mov	ax,DGROUP
	mov	ds,ax
	assume	ds:DGROUP
	call	far ptr _scheduler
	call	near ptr _exit21
Z08g:   POPR    <bp,es,di,si,dx,cx,bx>
	RESSTK	3
Z08h:   dec     cs:in_sched
;
;
        POPR    <dx,ax,ds>
	iret
_Int0f	endp


sd_poll	proc	near
	or	lastcmd,1
        mov     dx,cs:cmdport
	xor	al,al
	out	dx,al
	ret
sd_poll	endp

Int28Word 	label word
_Old_Int28	dd	?	; variavel no segmento de codigo

_Int28  proc	far
	inc	byte ptr cs:in_sched
	jnz	I28a
	sti
	PUSHR	<ax,bx,cx,dx,es,ds,di,si,bp>
	mov	ax,DGROUP
	mov	ds,ax
	assume	ds:DGROUP
	call	far ptr _check_ready
	test	ax,0ffh
	jz      I28g
	mov	ax,word ptr cs:swcntl
	mov	word ptr cs:dosswcnt,ax
	call	near ptr _entry21
	mov	ax,DGROUP
	mov	ds,ax
	assume	ds:DGROUP
	call	far ptr _scheduler
	call	near ptr _exit21
I28g:	POPR	<bp,si,di,ds,es,dx,cx,bx,ax>
I28a:	dec	byte ptr cs:in_sched
	jmp	dword ptr cs:[_Old_Int28]
_Int28	endp

Int13Word 	label word
_Old_Int13	dd	?	; variavel no segmento de codigo

_Int13  proc	far
	inc	byte ptr cs:_in_disk
	pushf
	cli
	call	dword ptr cs:[_Old_Int13]
	pushf
	dec	byte ptr cs:_in_disk
	popf
	retf	2
_Int13	endp

Int23Word 	label word
_Old_Int23	dd	?	; variavel no segmento de codigo

_Int23  proc	far
	iret
_Int23	endp

CritKeys	db	'aAtTiIfF'
keys_len	equ	$-CritKeys
CritCodes	db	2,2,1,1,0,0,3,3,3
HexBytes	db	'0123456789ABCDEF'
CritErrMsg	db	07h,0dh,0ah,'HandTerm -- Erro Critico: ',
CritErrCode	db	'  ',0dh,0ah,'Aborta, Tenta de novo, Ignora, Falha'
		db	0dh,0ah,'$'
Int24Word 	label word
_Old_Int24	dd	?	; variavel no segmento de codigo

_Int24  proc	far
	PUSHR	<bx,cx,dx,ds,es,si,di,bp>
	mov	ax,cs
	mov	ds,ax
	mov	es,ax
	assume	ds:DOSSW_TEXT,es:DOSSW_TEXT
	lea	si,CritErrCode
	mov	ax,di
	shr	al,1
	shr	al,1
	shr	al,1
	shr	al,1
	lea	bx,HexBytes
	xlat
	mov	byte ptr cs:[si],al
	mov	ax,di
	and	ax,0fh
	xlat
	mov	byte ptr cs:[si+1],al
I24a:	lea	dx,CritErrMsg
	mov     ax,0900h	; print string
	int	21h
	mov	ah,1		; aguarda uma tecla
	int	21h
	lea	di,CritKeys
	mov	cx,keys_len	; tamanho da string acima
	cld
	repne	scasb
	jnz	I24a
	mov	al,[di+keys_len-1]
	POPR	<bp,di,si,es,ds,dx,cx,bx>
	iret
_Int24	endp

Int2aWord 	label word
OldInt2a	dd	?	; variavel no segmento de codigo

CritSectLow     label   byte
CritSect	dw	0

_Int2a  proc	far
        sti
        cmp     ah,80h
	jne	I2a1
	push	cx
	push	ax
	mov	cl,al
	mov	ax,1
	and	cl,cl
	je	I2ad1
	shl	ax,cl
I2ad1:	or	word ptr cs:CritSect,ax	; set selected CritSect flag
	pop	ax
	pop	cx
	jmp	I2ac
I2a1:	cmp	ah,81h
	jne	I2a2
	push	cx
	push	ax
	mov	cl,al
	mov	ax,1
	and	cl,cl
	je	I2ad2
	shl	ax,cl
I2ad2:	not	ax
	and	word ptr cs:CritSect,ax	; clear selected CritSect flag
	pop	ax
	pop	cx
	jmp	I2ac
I2a2:   cmp	ah,82h
	jne	I2ac
	mov	byte ptr cs:CritSectLow,0 ; clear 0-7 CritSect flags	
I2ac:		; call other Int 2ah interceptors
        cli
        pushf
	call	dword ptr cs:[OldInt2a]
I2a3:	iret
_Int2a  endp

Int2fWord 	label word
_Old_Int2f	dd	?	; variavel no segmento de codigo
Int2fTmp        label word
                dd      ?

_Int2f  proc    far
	cmp	ah,0efh		; funcao de acesso local?
	jz	i2f1
	jmp     dword ptr cs:[_Old_Int2f]
i2f1:				; processa comandos locais
	and	al,al
	jnz	i2f2
	mov	al,0ffh
	jmp	i2fr
i2f2:	cmp	al,4
	jnz	i2fa1
        mov     ax,seg _syslist
	mov	ds,ax
        lea     ax,_syslist
	mov	si,ax
	mov	al,0
	jmp	i2fr
i2fa1:	cmp	al,1	; return server entry address
	jnz	i2f3
        xor     ax,ax
	mov	ds,ax
        mov     si,ax
        dec     ax
	jmp	i2fr
i2f3:	cmp	al,0fh		; desinstala o sistema
	jnz	i2f4
	sti
        push    ds
        mov     ax,DGROUP
	mov	ds,ax
	call	far ptr _mtnet_uninstall
        pop     ds
        mov     al,0
	jmp	i2fr
i2f4:	cmp	al,10h		; put char in system buffer
	jnz	i2f5
	push	dx		; character in DL
	mov	ax,DGROUP
	mov	ds,ax
	call	far ptr _put_sysch
	pop	cx
	jmp	i2fr
; ----------- Int2f -- ef81h
i2f5:   cmp     al,81h          ; envia buffer a TSRPROC
                                ; modificado para aguardar final
        jz      I2f5aa
        jmp     i2f6
I2f5aa:
;        int     05             ; ---- depuracao!!! ----
;        SAVSTK  1
        sti
I2f5a1: push    bx      ; ES:DX = pointer to external buffer
        push    cx
        push    dx
        push    ds
        push    es
        push    si
        push    di
        push    bp
;
        mov     ax,DGROUP
	mov	ds,ax
	assume 	ds:DGROUP
        sti
I2f5a:  test    byte ptr DGROUP:dummy_rdy,0ffh ; dummy ready?
        jnz      I2f5a2
        jmp     I2f5a  ; continua aguardando... dummy_rdy != 0
;
I2f5a2:
        mov     ax,es
        mov     word ptr [_usrptr+2],ax
        mov     word ptr [_usrptr],dx
        mov     byte ptr DGROUP:dummy_rdy,0       ; it will not be rdy anymore
        push    ds
        mov     ax,offset DGROUP:_dummy_semaf
        push    ax
        call    far ptr __signal          ; wake-up dummy proc
        add     sp,4
;************** insercao para aguardar final do processamento
        sti
I2floop:
        test     byte ptr DGROUP:dummy_rdy,0ffh
        jz       I2floop
;
saida:
        pop     bp
        pop     di
        pop     si
        pop     es
        pop     ds
        pop     dx
        pop     cx
        pop     bx
;        RESSTK  1
        jmp     i2fe            ; retorna dummy pronto
; --------- Int 2f - ef82h
i2f6:   cmp     al,82h          ; aguarda final do processamento (TSRPROC)
        jnz     i2fe
;        push    ds
;        mov     ax,DGROUP
;        mov     ds,ax
;        mov     al,DGROUP:dummy_rdy
;        xor     ah,ah
;        pop     ds
;        jmp     i2fr
        jmp     i2fe
;
i2fe:	mov	al,1
	stc         	; retorno com erro
i2fea:	iret
i2fr:	clc		; retorno com sucesso
	iret
_Int2f  endp

        public  _wait_tsr_msg
_wait_tsr_msg   proc far
;       int     05
        push    bp
        mov     bp,sp
        assume  ds:DGROUP
        mov     ax,offset DGROUP:_dummy_semaf       ;dummy_rdy+1
	push	ds
	push	ax
        mov     byte ptr DGROUP:dummy_rdy,1
	call	far ptr _wait
	add	sp,4
        mov     dx,word ptr [_usrptr+2]
        mov     ax,word ptr [_usrptr]
        pop     bp
        ret
_wait_tsr_msg   endp

        public  _end_tsr
_end_tsr        proc far
;        mov     byte ptr DGROUP:dummy_rdy,1
        ret
_end_tsr        endp

        public  _cript_check
_cript_check proc far
        push    bp
        mov     bp,sp
        push    bx
        mov     bx,word ptr [bp+6]
        mov     word ptr _criptword,bx
sri1:   mov     ax,word ptr _criptres
        and     ax,ax
        jz      sri1
        mov     word ptr _criptres,0
        pop     bx
        pop     bp
        ret
_cript_check endp

DOSSW_TEXT      ends

	end
