/*
**  Header file for Cobol Compiler Library
**
**  by Rildo Pragana -- 1991
**  P.O. Box 7440 - Recife PE Brazil 50000
**
**  Revision history:
**	28-oct-91 Code implementation
**
*/
#include <stdio.h>
#include <io.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <string.h>
#include <fcntl.h>
#include <ctype.h>
#include <stdarg.h>
#include <direct.h>
#include <time.h>
#include <math.h>

#include "bplus.h"
#include "mcprintf.h"
#include "mcvideo.h"
#include "mccntrl.h"

#define CR '\r'
#define DEL '\177'
#define BS '\b'

#define NUMTERM 32		/* numero de terminais */
#define MAXFILA 64		/* tamanho da fila do display */
#define MAX 1000
#define MAXCAMPO 10
#define MAXCCHR 16

typedef unsigned char byte;

struct evento {
	byte make;		/* make/break */
	char tecla;		/* tecla associada ao evento */
};

struct msg_block {
	byte pend;			/* indica evento pendente no terminal */
	byte on_line;			/* indica terminal on-line */
	byte alarme;			/* estado dos alarmes (3 leds) */
	byte e,s;			/* ponteiros de entrada e saida
						na fila do display */
	byte pe,ps;			/* idem, p/impressora */
	int fila[ MAXFILA ];		/* fila de caracteres a serem
						enviados ao display */
};

struct registers {
	unsigned int cs,ip,bx,cx,dx,bp,ds,es,ss,sp,si,di;
};
struct process_type {
	char *name;			/* ptr p/nome do processo */
	char termid;			/* endereco do mt100 */
	struct registers context[1];	/* area p/salvar o contexto */
	struct process_type *next;	/* link p/proximo da fila */
	unsigned int base;		/* init value for bp */
};
typedef struct process_type PROCESS;

typedef struct {
	int val;			/* valor do semaforo */
	PROCESS *p;			/* fila de processos em wait */
} SEMAF;

#define MICROSOFT 0	       /* 2=versao 2.2   4=versao 4.0 */
/* #define MICROBASE 1 */
#define NUMERIC_KBD 1   /* 0=phone, 1=numeric organization */

struct fld_desc {
	unsigned len;
	char type;
	unsigned char decimals;
	unsigned char times;
	char *pic;
};

struct file_desc {
	char *filename;
	unsigned reclen;	/* length of record */
	unsigned char organization;
				/* 1=INDEXED,2=SEQUENTIAL,3=RELATIVE */
	unsigned char access_mode;
				/* 1=SEQUENTIAL,2=DYNAMIC,3=RANDOM */
	int handle;		/* where to put file handle (global) */
	int users;		/* number or active users
					or printer port */
		/* second part: exists only if INDEXED file */
	unsigned rec_index; 	/* offset of index field in record */
	struct fld_desc
		*ixd_desc;	/* offset (DGROUP) index field descriptor */
	IX_DESC index;
	char sortkeys[1];
};

#define releasing splrec

/* before the 'entry' (below) is the 'record' array */

struct var_fd {
	long filepos;
	int splrec;
	ENTRY e;
	char record[1];
};
/*#define RECORD ((char *)(v->e.key)+\
	((f->organization==1)?f->ixd_desc->len+1:1))*/
#define RECORD ((char *)(v->record))

/* function prototipes */

void goxy( int,int );
void display( char *,int );
int accept( char *,struct fld_desc *,int );
void move( struct fld_desc *, char *,
	   struct fld_desc *, char * );
void add( struct fld_desc *, char *,
	  struct fld_desc *, char * );
void subtract( struct fld_desc *, char *,
	       struct fld_desc *, char * );
void multiply( struct fld_desc *, char *,
	       struct fld_desc *, char *,
	       struct fld_desc *, char * );
void stop_run( void );
int compare( struct fld_desc *, char *,
	      struct fld_desc *, char * );
int mc_open( struct file_desc *, struct var_fd *, int );

#ifdef MICROBASE
	int mc_close( struct file_desc *, struct var_fd * );
#else
	int mc_close( struct file_desc * );
#endif

int mc_read( struct file_desc *, struct var_fd *, ... );
int mc_write( struct file_desc *, struct var_fd * );
int mc_rewrite( struct file_desc *, struct var_fd * );
int get_index( struct fld_desc *, char * );
unsigned char mgetkey( void );
int submit_print( char * );
void init_spooler( void );

/* end of header file */
