/*
**	Programa Residente para acesso aos Microterminais
**  	Modulo de Utilitarios de Display
*/

#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <string.h>
#include <setjmp.h>
#include <ctype.h>
#include <memory.h>

#include "htnet.h"
#include "task.h"
#include "htdisp.h"

/*
** Mostra mensagem no display com formato especificado
*/
int mdisplay( format, buffer ) 
char *format;
char *buffer;
{
	int cnt=0;
	int first=0;
	/* char sign=0; */
	while (*format) {
		switch(*format++) {
		case '9': if (!first) {
				if (*buffer == '+' || *buffer == '-') {
					/* sign= */ *buffer++; /* ignore sign */
				}
				else if (*buffer != '0') {
					mputc(*buffer++);
					cnt++;
					first++;
				}
				else {
					mputc(' ');
					buffer++;
				}
			  }
			  else  {
				mputc(*buffer++);
				cnt++;
			  }
			  break;
		case 'A':
		case 'X':
		case 'Z': mputc(*buffer++); cnt++; break;
		default: if (first) { mputc(*(format-1)); cnt++; }
		}
	}
	return cnt;
}

/* funcao auxiliar para alinhamento de campos numericos */
char *justify_numeric( format, buffer, buf, flg ) 
char *format;
char *buffer;
char *buf;
int flg;
{
	char *b,*e,*r;
	b=buffer;
	while (*format!=',' && *format) { /* encontra pt decimal */
		if (*format=='9') b++;
		format++;
	}
	r=e=b--;
	while (buf>buffer)
		*b--=*(--buf);
	while (b>=buffer) *b--='0';
	while (*format)
		if (*format++=='9') *e++='0';
	if (flg) return e;
	else return r;
}

/*
** Introducao de um campo com prompt
*/

int minput( msg, format, buffer )
char *msg;
char *format;
char *buffer;
	/* msg -- mensagem (prompt) a ser mostrada */
	/* format -- formato de entrada A=alfa, X=alfanum, 9=num */
	/*  se o primeiro caracter = \x1 --> entrada sem eco */
	/*  se o primeiro caracter = \x2 --> entrada sem nulo no final */
	/*  se o primeiro caracter = \x3 --> entrada sem separadores */
	/*  se o primeiro caracter = \x4 --> entrada de numeros (cobol)
					ou strings com preenchimento */
	/* buffer -- aonde armazenar */
{
	char c;
	char *fmt,*buf,*tmp;
	byte pos[2]; /* para armazenar a posicao apos a msg */
	int echo_star=0;
	int no_null=0;
	int no_separator=0;
	int zero_fill=0;
	int decimal=0;
	int alpha=0;
	while (*format>='\x1' && *format<='\x4') {
		switch (*format) {
		case '\x1': echo_star++; format++; break;
		case '\x2': no_null++; format++; break;
		case '\x3': no_separator++; format++; break;
		case '\x4': zero_fill++; no_separator++; format++; break;
		}
	}
	fmt=format;
	buf=buffer;
	mputstr(msg);
	mgetpos(pos);
	while (*fmt) {
		switch(*fmt) {
		case 'A':
		case 'X':
		case 'Z':
			alpha=1;
		case '9':
			c=mgetkey();
			switch (c) {
			case DEL:
				if (buf==buffer) return -1;
				msetpos(pos);
				tmp=buffer;
				while (tmp++!=buf) mputc(' '); /* limpa campo */
				msetpos(pos);
				fmt=format;
				buf=buffer;
				break;
			case BS:
				if (fmt>format) {
					fmt--; buf--;
					mputc('\b');
					while ( *fmt!='A' && *fmt!='X' &&
						*fmt!='9' && *fmt!='Z' &&
						fmt>format ) {
						fmt--;
						if (!no_separator)
							buf--;
						mputc('\b');
					}
				}
				break;
			case CR:
				goto final;
			default:
				if ( 	(*fmt=='A') && (isalpha(c) || c==' ') ||
					(*fmt=='X') && (isalnum(c) || c==' ') ||
					(*fmt=='9') && isdigit(c) ||
					(*fmt=='Z') && isprint(c) ) {
					*(buf++) = c;
					if (echo_star) mputc('*');
					else mputc(c);
					fmt++;
				}
				else if (!isalnum(c)) {
				   /* testa presenca de 'c' em fmt */
				   tmp=fmt;
				   while ((*tmp!=0) && ((*tmp)!=c)) tmp++;
				   if (*tmp==c) {
						fmt=tmp;
						c = *fmt++;
						if (!no_separator)
							*buf++ = c;
						if (echo_star) mputc('*');
						else mputc(c);
				   }
				   if (c==',' && zero_fill!=0 && !alpha ) {
					/* alinha campo numerico a direita
					   e preenche com zeros */
					buf=justify_numeric( format,buffer,buf,0 );
					decimal++;
				   }
				}
			}
			break;
		default:
			c=*fmt++;
			if (c==',' && zero_fill) decimal++;
			if (!no_separator) *(buf++) = c;
			if (echo_star) mputc('*');
			else mputc(c);
			break;
		}
	}
final:
	if (zero_fill && !decimal && !alpha) {
		buf=justify_numeric( format,buffer,buf,1 );
	}
/*	else if (zero_fill && !alpha) -- preenche com zeros --
		while (*fmt++) *(buf++)='0'; */
	else if (zero_fill && alpha)
		while (*fmt++) *(buf++)=' ';
	if (!no_null) *buf=0;
	return (int) (buf-buffer);
}

/*
** mostra o erro no terminal e aguarda uma tecla
*/
void mterror( s ) char *s; {
	if (s[0]!=0)
		mprintf("%s: %s",s,sys_errlist[errno]);
	else
		mprintf("%s",sys_errlist[errno]);
	mgetkey();
}

