;
;	Programa Residente para acesso aos Microterminais
;	Modulo Driver de Interrupcoes
;	Rildo Pragana -- 07/07/93
;

DOSSW_TEXT	segment	byte public 'CODE'
DGROUP	group	_DATA,_BSS
	assume	cs:DOSSW_TEXT,ds:DGROUP,ss:DGROUP
DOSSW_TEXT	ends

extrn	__signal:far,_wait:far,_scheduler:far
extrn	_process_event:far,_get_key:far
extrn	_check_ready:far
extrn  	_signal_timer:far
extrn	_mtnet_uninstall:far
extrn	_put_sysch:far
_DATA	segment word public 'DATA'
d@	label	byte
d@w	label	word
_DATA	ends

_VIDEO_SEG segment byte public at 0B800h 'VIDEO_SEG'
_VIDEO_SEG ends

extrn	_msg_blk_size:word,_terminais:far
;extrn	_ftimer:byte
extrn	_timer_data:word
extrn	_polling:byte,_sdsp:far,_semaf_size:word
extrn	_syslist:far
extrn	__psp:word

_BSS	segment word public 'BSS'
b@	label	byte
b@w	label	word
_BSS	ends

;TESTVER	equ	1	; comentar para versao de uso normal

MAXFILA	equ	64

eoff	equ	3
soff	equ	4
peoff	equ	5
psoff	equ	6
fila	equ	7

_DATA	segment word public 'DATA'

dispdt		db	?
_fatortimer	db	1
lastcmd		db	1		  ; 1 = polling
_inRefresh	db	0ffh
rtty		db	0		  ; term # for refresh
rnumb		db	?		  ; no of term without chars
rsdsp		dw	offset _sdsp	  ; disp semaf for refresh
rtermp		dw	offset _terminais ; term struct pointer for refresh
_mdisp	db	?
sdsp	dw	?
count	dw	?
tty	dw	?

_DATA	ends

DOSSW_TEXT	segment	byte public 'CODE'
assume	ds:DGROUP,cs:DOSSW_TEXT,ss:DGROUP

PUBLIC	_keep_pgm
PUBLIC	_desinstala

PUSHR	MACRO	Rlist
	IRP	R,<Rlist>
	push	R
	ENDM
	ENDM

POPR	MACRO	Rlist
	IRP	R,<Rlist>
	pop	R
	ENDM
	ENDM

SAVSTK	MACRO	N
	mov	word ptr cs:ax_sav&N,ax
	mov	word ptr cs:sp_sav&N,sp
	mov	ax,ss
	mov	word ptr cs:ss_sav&N,ax
	mov	ax,DOSSW_TEXT
	mov	ss,ax
	lea	sp,locstk&N
	mov	ax,word ptr cs:ax_sav&N
	ENDM

RESSTK	MACRO	N
	mov	word ptr cs:ax_sav&N,ax
	mov	sp,word ptr cs:sp_sav&N
	mov	ax,word ptr cs:ss_sav&N
	mov	ss,ax
	mov	ax,word ptr cs:ax_sav&N
	ENDM

INSTALLINT	MACRO	Inum,IFun,OldVect
	mov	di,(Inum*4)		; instala Int<Inum>
	mov	ax,word ptr es:[di]
	mov	cs:OldVect,ax
	mov	ax,word ptr es:[di+2]
	mov	cs:OldVect+2,ax
	lea	ax,IFun
	mov	word ptr es:[di],ax
	mov	ax,DOSSW_TEXT
	mov	word ptr es:[di+2],ax
	ENDM

UNINSTALL	MACRO	Inum,OldVect
	mov	di,(Inum*4)
	mov	ax,cs:OldVect
	mov	word ptr es:[di],ax
	mov	ax,cs:OldVect+2
	mov	word ptr es:[di+2],ax
	ENDM

in_sched	db	0	; sera' decrementado (0ffh) na inicializacao

	dw	400h dup (?)
locstk1	dw	?
sp_sav1	dw	?
ss_sav1	dw	?
ax_sav1	dw	?
	dw	400h dup (?)
locstk2	dw	?
sp_sav2	dw	?
ss_sav2	dw	?
ax_sav2	dw	?
	dw	400h dup (?)
locstk3	dw	?
sp_sav3	dw	?
ss_sav3	dw	?
ax_sav3	dw	?

schedft		dw	10
sch_ticks	dw	10

IFDEF	TESTVER
video_sav	dw	5 dup (?)
ENDIF
_entry21	proc	near
	PUSHR	<ax,cx,es,ds,di,si>
	cld
	mov	ax,cs
	mov	es,ax
	assume	es:DOSSW_TEXT
	lea	di,DosArea		; ES:DI --> &DosArea
	lds	si,dword ptr cs:[DosVPnt]       ; DS:SI --> DosVPnt
	mov	cx,word ptr cs:dosswcnt         ; CX    --> dosswcnt
	shr	cx,1
	rep	movsw
	mov	ax,cs
	mov	ds,ax
	assume	ds:DOSSW_TEXT
	lea	si,LocArea
	les	di,dword ptr cs:[DosVPnt]
	mov	cx,word ptr cs:dosswcnt
	shr	cx,1
	rep	movsw
	xor	ax,ax		; endereca segmento de vetores de intr
	mov	es,ax
	INSTALLINT	23h,_Int23,Int23Word
	INSTALLINT	24h,_Int24,Int24Word
IFDEF	TESTVER
	; ****** Mostra acesso em background no video
	mov	ax,0b800h
	mov	ds,ax
	assume	ds:VIDEO_SEG
	mov	si,0
	mov	ax,ds:[si]
	mov	word ptr video_sav,ax
	mov	ax,0f57h
	mov	ds:[si],ax
	; ******
ENDIF
	POPR	<si,di,ds,es,cx,ax>
	ret
_entry21	endp

_exit21	proc	near
	PUSHR	<ax,cx,es,ds,di,si>
	cld
	mov	ax,cs
	mov	es,ax
	assume	es:DOSSW_TEXT
	lea	di,LocArea
	lds	si,dword ptr cs:[DosVPnt]
	assume	ds:DOSSW_TEXT
	mov	cx,word ptr cs:dosswcnt
	shr	cx,1
	rep	movsw
	mov	ax,cs
	mov	ds,ax
	assume	ds:DOSSW_TEXT
	lea	si,DosArea               ; DS:SI --> &DosArea
	les	di,dword ptr cs:[DosVPnt]	; ES:DI --> DosVPnt
	mov	cx,word ptr cs:dosswcnt		; CX    --> dosswcnt
	shr	cx,1
	rep	movsw
	xor	ax,ax		; endereca segmento de vetores de intr
	mov	es,ax
	UNINSTALL	23h,Int23Word
	UNINSTALL	24h,Int24Word
IFDEF	TESTVER
	; ****** Mostra acesso em background no video
	mov	ax,0b800h
	mov	ds,ax
	assume	ds:VIDEO_SEG
	mov	si,0
	mov	ax,word ptr video_sav
	mov	ds:[si],ax
	; ******
ENDIF
	POPR	<si,di,ds,es,cx,ax>
	ret
_exit21	endp

_rdKeyb	db	0
_in_disk	db	0
dosPSP		dw	?
locPSP		dw	?
dosswcnt	dw	?
swcnth		dw	?
swcntl		dw	?
DosVWord	label	word
DosVPnt         dd	?
DosArea		db	800h dup (?)
LocArea		db	800h dup (?)

InstErrMsg	db	0dh,0ah,'Erro fatal na instalacao',0dh,0ah
		db	'Informe a HandTerm!$'

_keep_pgm	proc	far
	arg	paragraphs:word,ticks:word
	push	bp
	mov	bp,sp
	push	bp
	mov	ah,62h
	int	21h
	mov	word ptr cs:locPSP,bx
	mov	ax,5d06h	; get msdos areas
	Int	21h
	mov	word ptr cs:dosswcnt,cx
	mov	word ptr cs:swcnth,cx
	mov	word ptr cs:swcntl,dx
	mov	word ptr cs:DosVWord,si
	mov	word ptr cs:DosVWord+2,ds
	mov	ax,cs
	mov	es,ax
	lea	di,LocArea   ; save a copy of area2
	cld
	rep 	movsb
	lds	si,dword ptr cs:[DosVPnt]
	sub	si,0bh
	mov	al,50h	; 'push ax'
	cli
	mov	bx,word ptr ds:[si]
	mov	byte ptr ds:[bx],al
	mov	bx,word ptr ds:[si+2]
	mov	byte ptr ds:[bx],al
	mov	bx,word ptr ds:[si+4]
	mov	byte ptr ds:[bx],al
	mov	bx,word ptr ds:[si+6]
	mov	byte ptr ds:[bx],al
	pop	bp
	mov	ax,DGROUP
	mov	ds,ax
	xor	ax,ax		; endereca segmento 0 (vetores)
	mov	es,ax
	INSTALLINT	13h,_Int13,Int13Word
	INSTALLINT	2fh,_Int2f,Int2fWord
	INSTALLINT	2ah,_Int2a,Int2aWord
	INSTALLINT	28h,_Int28,Int28Word
	INSTALLINT	08h,_Int08,Int08Word
	INSTALLINT	0fh,_Int0f,Int0fWord
;
	mov	dx,21h
	in	al,dx
	and	al,7fh
	out	dx,al
	xor	al,al
	mov	dx,301h
	out	dx,al
;
	mov	dx,[ticks]
	mov	word ptr cs:sch_ticks,dx
	dec	cs:in_sched		; ativa o scheduler
	dec	byte ptr _polling	; ativa o polling
	mov	dx,[paragraphs]
	mov	ax,3100h
	int	21h
	mov	ax,0900h   		; para o caso de retorno (erro?)
	lds	dx,dword ptr cs:[InstErrMsg]
	int	21h
	cli
	hlt
_keep_pgm	endp

_desinstala	proc	far
	pushf
	cli
	push	ax
	push	es
	push	di
	xor	ax,ax
	mov	es,ax
;
	push	dx
	mov	dx,21h
	in	al,dx
	or	al,80h
	out	dx,al
	pop	dx
;
	UNINSTALL	0fh,Int0fWord
	UNINSTALL	08h,Int08Word
	UNINSTALL	2ah,Int2aWord
	UNINSTALL	2fh,Int2fWord
	UNINSTALL	28h,Int28Word
	UNINSTALL	13h,Int13Word
	pop	di
	pop	es
	pop	ax
	popf
	ret
_desinstala	endp

;
;	******************     D R I V E R S     *********************
;

Int08Word 	label word
_Old_Int08	dd	?	; variavel no segmento de codigo

_Int08  proc	far
I08a:	PUSHR	<ds,ax>
	mov	ax,DGROUP
	mov	ds,ax
	assume	ds:DGROUP
	pushf
	call	dword ptr cs:[_Old_Int08]
;
; ======= verifica se existe algum display necessitando servico
;
	test	_mdisp,0ffh	; ja' marcado p/atualizacao?
	jnz	I08norm
	push	si
	push	cx
	xor	cl,cl
	mov	si,offset _terminais
mdchk:
	mov	al,[si+eoff]	; compara entrada=saida
	sub	al,[si+soff]
	jz      mdprox
	inc	_mdisp
	pop	cx
	pop	si
	jmp	I08norm
mdprox:
	add	si,_msg_blk_size
	inc	cl
	cmp	cl,32
	jnz	mdchk
	pop	cx
	pop	si
; ****************** teste
;	jmp	I08b
;
I08norm:
;	SAVSTK	1
;	sti
;	PUSHR	<bx,cx,dx,si,di,es,bp>
;	call	far ptr _signal_timer
;	POPR	<bp,es,di,si,dx,cx,bx>
;	RESSTK	1
I08y:   sti
	inc	byte ptr cs:in_sched
	jz	I08w
	jmp	I08h
I08w:	SAVSTK	3
	PUSHR	<bx,cx,dx,si,di,es,bp>
	mov	ax,DGROUP
	mov	ds,ax
	assume	ds:DGROUP
	call	far ptr _signal_timer
	call	far ptr _check_ready
	test	ax,0ffh
	jz      I08g
	test	byte ptr cs:CritSect,0ffh
	jnz	I08g
	test	byte ptr cs:_in_disk,0ffh
	jnz	I08g
	lds	si,dword ptr cs:[DosVPnt]
	mov	ax,word ptr ds:[si]
	or	ah,al
	mov	ax,word ptr cs:swcntl
	jz	I08j
	mov	ax,word ptr cs:swcnth
I08j:	mov	word ptr cs:dosswcnt,ax
	call	near ptr _entry21
	mov	ax,DGROUP
	mov	ds,ax
	assume	ds:DGROUP
	call	far ptr _scheduler
	call	near ptr _exit21
I08g:	POPR	<bp,es,di,si,dx,cx,bx>
	RESSTK	3
I08h:   dec	byte ptr cs:in_sched
I08b:	pop	ax
	pop	ds
	iret
_Int08	endp

Int0fWord 	label word
_Old_Int0f	dd	?	; variavel no segmento de codigo

_refresh	proc	near
; **************** teste
;	stc
;	ret
;
	jc	nextdisp		; inicializa refresh?
	test	_mdisp,0ffh
	jnz	rfshinit
	stc
	jmp	itend
rfshinit:
	mov	rtty,0			; contador de terminais
	mov	rnumb,0
	lea	ax,_sdsp
	mov	rsdsp,ax 		; ponteiro p/os semaforos
	lea	ax,_terminais
	mov	rtermp,ax		; pont. p/estruturas (array)
nextdisp:
	cmp	rtty,32			; last tty?
	jne	itsend
	cmp	rnumb,32
	jnz     scanok
	mov	_mdisp,0
scanok:
	stc				; return error
	jmp     itend
itsend:
	push	si
	mov	si,rtermp
;
; ====> refresh led indicators
;
itleds:
	test	byte ptr [si+2],80h
	jz	it3
	xor	byte ptr [si+2],80h
	mov	al,byte ptr [si+2]
	xor	al,0ffh
	mov	dx,300h
	out	dx,al
	mov	al,rtty		; endereco do terminal
	shl	al,1
	shl	al,1
	shl	al,1
	or	al,4		; combine comando WR_LEDS+endereco
	mov	byte ptr dispdt,al
	mov	lastcmd,0
	clc
	pop	si
	jmp	itend
;
it3:	mov	al,[si+eoff]	; compara entrada=saida
	sub	al,[si+soff]
	jnz	itenvia
	jmp	itempty		; se vazio (buffer), skip
;
; <--------------- envia dados ao display ---------------------->
;
itenvia:
	PUSHR	<di,es,bx,cx,bp>
	mov	ax,si		; obtenha proximo caracter do buffer
	add	ax,fila
	add	al,[si+soff]
	adc	ah,0
	add	al,[si+soff]
	adc	ah,0
	mov	bx,ax
	mov	al,[bx]
	test	byte ptr [bx+1],1
	jnz	itcomm
itdata:			; envia dados ao display
	mov	dx,300h
	out	dx,al
	mov	al,rtty
	shl	al,1
	shl	al,1
	shl	al,1
	or	al,2	; comando send-display-data
;	inc	dx
;	out	dx,al
	mov	byte ptr dispdt,al
	jmp	itcd
itcomm:			; envia comando ao display
	mov	dx,300h
	out	dx,al
	mov	al,rtty
	shl	al,1
	shl	al,1
	shl	al,1
	or	al,1	; comando send-display-command
;	inc	dx
;	out	dx,al
	mov	byte ptr dispdt,al
itcd:
	mov	si,rtermp
	mov	al,byte ptr[si+soff]	; avanca o ponteiro de saida
	inc	al
	and	al,MAXFILA-1		; mascare o ponteiro p/evitar estouro
	mov	byte ptr[si+soff],al	; armazene-o de volta
	cmp	al,byte ptr [si+eoff]
	jne	itcd1			; sinaliza somente quando vazio
	push	ds
	mov	ax,rsdsp
	push 	ax
	call	far ptr __signal
	add	sp,4
itcd1:
	POPR	<bp,cx,bx,es,di>
;
; <------------------ dados enviados ao display ------------------->
;
	mov	ax,rtermp
	add	ax,_msg_blk_size	; proximo terminais[term] do array
	mov     rtermp,ax
	mov	ax,rsdsp
	add	ax,_semaf_size		; proximo semaforo do array
	mov	rsdsp,ax
	inc	rtty			; avanca contador de terminais
	mov	lastcmd,0
	clc
	pop	si
	jmp	itend
itempty:
	inc	rnumb
	mov	ax,rtermp
	add	ax,_msg_blk_size	; proximo terminais[term] do array
	mov     rtermp,ax
	mov	ax,rsdsp
	add	ax,_semaf_size		; proximo semaforo do array
	mov	rsdsp,ax
	inc	rtty			; avanca contador de terminais
	pop	si
	jmp	nextdisp
itend:
	ret
_refresh	endp

sd_poll	proc	near
	or	lastcmd,1
	mov	dx,301h
	xor	al,al
	out	dx,al
	ret
sd_poll	endp

_Int0f  proc	far
	PUSHR	<ds,ax,dx>
	mov	ax,DGROUP
	mov	ds,ax
	assume	ds:DGROUP
	mov	al,20h		; EOI para o 8259
	out	20h,al
;	inc	byte ptr _inRefresh
;	jz	I0finit
;	jmp	I0ftt
I0finit:
; ****************** teste
;	jmp	I0ftt
;
	test	lastcmd,1	; last command was polling?
	jnz	I0fpoll
	jmp	I0fb
I0fpoll:
	mov	dx,301h
	in	al,dx
	test	al,2		; time out?
	jnz	I0fa		; no key pending
	SAVSTK	2
	sti
	PUSHR	<bx,cx,si,di,bp,es>
	mov	bl,al
	shr	bl,1
	shr	bl,1
	shr	bl,1
	and	bl,1fh		; endereco do terminal
	dec	dx
	in	al,dx		; tecla
	test	al,80h
	jz	I0fperr		; erro de polling
	test	al,40h
	jnz	I0fperr
	mov	ah,al
	shr	al,1
	shr	al,1
	shr	al,1
	shr	al,1
	and	al,1
	xor	al,1
	and	ah,0fh
	push	ax
	push	bx
	call	far ptr _process_event
	add	sp,4
I0fperr:
	POPR	<es,bp,di,si,cx,bx>
	cli
	RESSTK	2
	jmp	I0ftt
I0fa:
	dec	byte ptr _fatortimer
	jz	I0fd
	jmp	I0ftt
I0fd:
	mov	byte ptr _fatortimer,5		; aprox. 5 ms
	sti
	clc
	call	near ptr _refresh
	jc	I0ftt
	cli
	mov	al,dispdt
	mov	dx,301h
	out	dx,al
	jmp	I0fend
I0fb:				; last command was not polling
	sti
	stc                     ; continue refresh
	call	near ptr _refresh
	jc	I0ftt
	cli
	mov	al,dispdt
	mov	dx,301h
	out	dx,al
	jmp	I0fend
I0ftt:
	call	near ptr sd_poll
I0fend:
;	dec	byte ptr _inRefresh
	POPR	<dx,ax,ds>
	iret
_Int0f	endp

Int28Word 	label word
_Old_Int28	dd	?	; variavel no segmento de codigo

_Int28  proc	far
	inc	byte ptr cs:in_sched
	jnz	I28a
	sti
	PUSHR	<ax,bx,cx,dx,es,ds,di,si,bp>
	mov	ax,DGROUP
	mov	ds,ax
	assume	ds:DGROUP
	call	far ptr _check_ready
	test	ax,0ffh
	jz      I28g
	mov	ax,word ptr cs:swcntl
	mov	word ptr cs:dosswcnt,ax
	call	near ptr _entry21
	mov	ax,DGROUP
	mov	ds,ax
	assume	ds:DGROUP
	call	far ptr _scheduler
	call	near ptr _exit21
I28g:	POPR	<bp,si,di,ds,es,dx,cx,bx,ax>
I28a:	dec	byte ptr cs:in_sched
	jmp	dword ptr cs:[_Old_Int28]
_Int28	endp

Int13Word 	label word
_Old_Int13	dd	?	; variavel no segmento de codigo

_Int13  proc	far
	inc	byte ptr cs:_in_disk
	pushf
	cli
	call	dword ptr cs:[_Old_Int13]
	pushf
	dec	byte ptr cs:_in_disk
	popf
	retf	2
_Int13	endp

Int23Word 	label word
_Old_Int23	dd	?	; variavel no segmento de codigo

_Int23  proc	far
	iret
_Int23	endp

CritKeys	db	'aAtTiIfF'
keys_len	equ	$-CritKeys
CritCodes	db	2,2,1,1,0,0,3,3,3
HexBytes	db	'0123456789ABCDEF'
CritErrMsg	db	07h,0dh,0ah,'HandTerm -- Erro Critico: ',
CritErrCode	db	'  ',0dh,0ah,'Aborta, Tenta de novo, Ignora, Falha'
		db	0dh,0ah,'$'
Int24Word 	label word
_Old_Int24	dd	?	; variavel no segmento de codigo

_Int24  proc	far
	PUSHR	<bx,cx,dx,ds,es,si,di,bp>
	mov	ax,cs
	mov	ds,ax
	mov	es,ax
	assume	ds:DOSSW_TEXT,es:DOSSW_TEXT
	lea	si,CritErrCode
	mov	ax,di
	shr	al,1
	shr	al,1
	shr	al,1
	shr	al,1
	lea	bx,HexBytes
	xlat
	mov	byte ptr cs:[si],al
	mov	ax,di
	and	ax,0fh
	xlat
	mov	byte ptr cs:[si+1],al
I24a:	lea	dx,CritErrMsg
	mov     ax,0900h	; print string
	int	21h
	mov	ah,1		; aguarda uma tecla
	int	21h
	lea	di,CritKeys
	mov	cx,keys_len	; tamanho da string acima
	cld
	repne	scasb
	jnz	I24a
	mov	al,[di+keys_len-1]
	POPR	<bp,di,si,es,ds,dx,cx,bx>
	iret
_Int24	endp

Int2aWord 	label word
OldInt2a	dd	?	; variavel no segmento de codigo

CritSect	db	0

_Int2a  proc	far
	sti
	pushf
	cmp	ah,80h
	jne	I2a1
	or	byte ptr cs:CritSect,al
	jmp	I2a2
I2a1:	cmp	ah,81h
	jne	I2a2
	not	al
	and	byte ptr cs:CritSect,al
I2a2:   popf
	pushf
	call	dword ptr cs:[OldInt2a]
	jnc	I2a3
	test	byte ptr cs:CritSect,0ffh
	jz	I2a3
I2a5:	push	bp
	mov	bp,sp
	mov	ax,1
	or	word ptr [bp+6],ax
	pop	bp
I2a3:	iret
_Int2a	endp

Int2fWord 	label word
_Old_Int2f	dd	?	; variavel no segmento de codigo

_Int2f	proc	far
	cmp	ah,0efh		; funcao de acesso local?
	jz	i2f1
	jmp     dword ptr cs:[_Old_Int2f]
i2f1:				; processa comandos locais
	and	al,al
	jnz	i2f2
	mov	al,0ffh
	jmp	i2fr
i2f2:	cmp	al,4
	jnz	i2f3
	mov	ax,seg _syslist
	mov	ds,ax
	lea	ax,_syslist
	mov	si,ax
	mov	al,0
	jmp	i2fr
i2f3:	cmp	al,0fh		; desinstala o sistema
	jnz	i2f4
	sti
	mov	ax,DGROUP
	mov	ds,ax
	call	far ptr _mtnet_uninstall
	mov	al,0
	jmp	i2fr
i2f4:	cmp	al,10h		; put char in system buffer
	jnz	i2fe
	push	dx		; character in DL
	mov	ax,DGROUP
	mov	ds,ax
	call	far ptr _put_sysch
	pop	cx
	jmp	i2fr
i2fe:	mov	al,1
	stc         	; retorno com erro
	iret
i2fr:	clc		; retorno com sucesso
	iret
_Int2f	endp

DOSSW_TEXT	ends

	end
