/*
**	Modulo de comunicacao e instalacao
*/

#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <direct.h>
#include <memory.h>
#include <process.h>
#include <stdlib.h>
#include <malloc.h>

#include "htnet.h"
#include "task.h"
#include "getargs.h"
#include "mccntrl.h"

extern PROCESS *running;
void keep_pgm( /* unsigned paragraphs, int sched_ticks */ );
void scheduler( );
void instala_int( );
void desinstala( );
void mtnet_exit( );

/*	Defines relacionados com comunicacao	*/

#define ARGTABSIZE (sizeof(Argtab)/sizeof(ARG))


/***************  V A R I A V E I S  ***********************/

extern SEMAF sioready, sdsp[], skey[], sprt[];
/*extern void *_heaptop; */ /* final da heap do Turbo C */

void get_bits( /*byte nbits , byte *c*/ );
void send_bits( /*byte nbits, byte dados*/ );

struct msg_block terminais[NUMTERM]={0};
unsigned int msg_blk_size=sizeof(struct msg_block);
unsigned int semaf_size=sizeof(SEMAF);
static unsigned paragraphs;
static unsigned malloc_blk=0;
static unsigned env_seg=0;
byte polling = 0;	/* indica polling em andamento */
unsigned timer_data;
static int mapmem=0;
int uninstall=0;
static int sched_ticks=10;
static int alocpar=40; /* default de 40 paragrafos alocados */
static int nfopen=20;
union REGS reg,oreg;
struct SREGS segr;

static ARG Argtab[] = {
/* 		Tabela de argumentos de mtnet_init			*/
/* 	switch	tipo	variavel	msg				*/
	{ 'q',	BOOLEAN, &uninstall,	"desinstala pgm residente"},
	{ 's',  INTEGER, &sched_ticks,	"numero de ticks p/acesso ao OS"},
	{ 'a',	INTEGER, &alocpar,
		"paragrafos de memoria (16 bytes) reservadas"},
	{ 'o',  INTEGER, &nfopen,	"handles para arquivos"}
};

int getargs( int, char **, ARG *, int );

void list_mem( ) {
	unsigned *env;
	union {
		void *p;
		struct {
			unsigned o;
			unsigned s;
		} w;
	} heap_end;
	/* Devera' preparar a variavel _heaptop (_heapbase e' constante)
	   do Turbo C para apontar para o final da heap permitida */
	unsigned len;
	heap_end.p = malloc(1);
	free( heap_end.p );
	len = heap_end.w.s + (heap_end.w.o/16)+1+alocpar;
	paragraphs= (unsigned)(len - _psp);
	env = MK_FP(_psp,0x2c); /* environment pointer in PSP */
	env_seg = *env;
}

struct mcb {
	unsigned char typ;
	unsigned owner;
	unsigned size;
} far *mcbp;
unsigned far *mcbseg;

void mtnet_uninstall( ) {
	disable();
	polling++;		/* bloqueia polling p/ sair */
	while (running != NULL) ;
	desinstala();		/* restitue vetores de interrupcao default */
/*	enable();*/
	/* while ( (polling!=0) || (gerando!=0) ); */
/*	freemem( env_seg );
	freemem( malloc_blk );
	freemem( _psp );
*/
	reg.h.ah = 0x52;
	_intdosx( &reg,&oreg,&segr );
	mcbseg = MK_FP( segr.es,oreg.x.bx-2 );
	mcbp = MK_FP( *mcbseg,0 );
/*printf( "MCB: %04x:%04x\nPSP: %04x\n",FP_SEG(mcbp),FP_OFF(mcbp),_psp);*/
	while( mcbp->typ == 0x4d ) {
		if (mcbp->owner == _psp)
			freemem( FP_SEG( mcbp ) + 1 );
		mcbp = MK_FP( FP_SEG( mcbp ) + mcbp->size + 1 ,
				FP_OFF( mcbp ) );
	}

}

void mtnet_init( argc,argv  )
int argc;
char **argv;
{
	void **handle_tbl;
	void *old_tbl;
	int far *handle_cnt;
	unsigned *blk;
	byte i;
	getargs( argc, argv, Argtab, ARGTABSIZE );
	if (uninstall!=0) { /* switch p/desinstalar */
		reg.x.ax=0xef00;
		int86( 0x2f, &reg, &oreg );
		if ((oreg.x.ax & 0x0f)==0)
			fprintf(stderr,"\nRede HandTerm no instalada!\n");
		else {
			reg.x.ax=0xef0f;
			int86( 0x2f,&reg,&oreg );
			printf("\nRede HandTerm retirada da memoria\n");
		}
		exit(0);
	};
	reg.x.ax=0xef00;	/* Int2f-ef, funcao 00 - get init status */
	int86( 0x2f, &reg, &oreg );
	if ( (oreg.x.ax & 0x0f) != 0 ) {
		fprintf( stderr,"\nRede HandTerm j foi instalada anteriormente.\n");
		exit(0);
	}
	blk = (unsigned *)malloc(1);
			/* first blk alloc to free all memory later */
	malloc_blk = FP_SEG( blk ); /* save its segment */
	if (nfopen>20) {
		handle_tbl=(void **)MK_FP(_psp,0x34);
		old_tbl=*handle_tbl;
		*handle_tbl = calloc( nfopen,sizeof(byte) );
		handle_cnt=MK_FP(_psp,0x32);
		set_bytes( *handle_tbl,0xff,nfopen );
		move_bytes( *handle_tbl,old_tbl,*handle_cnt );
		*handle_cnt = nfopen;
	}
	for (i=0;i<NUMTERM;i++) {
		terminais[i].alarme=0x87;	/* desliga todos os alarmes */
		terminais[i].e = terminais[i].s = 0;
		terminais[i].pe = terminais[i].pe = 0;
	}
}

void mtnet_install( )
{
	int i;
	clrscr();
    /*polling++; */     /* indica polling em andamento
				   sera desligado em keep_pgm */
	printf("\nRede de Microterminais HandTerm\n(C) 1993 HandTerm Tecnologia\n");
	for (i=0;i<NUMTERM;i++) {
		terminais[i].on_line = 0;
        liga_alarmes( i,"DDDLL" );
	}
	list_mem();
	disable();
	keep_pgm(paragraphs,sched_ticks);
}

/* Final do Modulo */
