/*
**  Cobol Compiler Library -- General Utility Module
**
**  by Rildo Pragana -- 1991
**  P.O. Box 7440 - Recife PE Brazil 50000
**
**  Revision history:
**	29-oct-91 Code implementation
**	24-dec-91 Separate library for files
**
*/

void *get_syslist();
#include "htcoblib.h"
#include "getargs.h"
#define TID (((struct process_type *)(*(void **)(*((void **)syslist+1))))->termid)
#define MAIN_START ((SEMAF *) ((*((void **)syslist+10))))
#define min(x,y) ((x)<(y) ? (x) : (y))

void *dos_alloc();
int alocpar = 0;
int convmem = 0;
#define ARGTABSIZE (sizeof(Argtab)/sizeof(ARG))
static ARG Argtab[] = {
/* 		Tabela de argumentos de mtnet_init			*/
/* 	switch	tipo	variavel	msg				*/
	{ 'a',	INTEGER, &alocpar,
		"paragrafos de memoria (16 bytes) reservadas"},
	{ 'c',  BOOLEAN, &convmem,
		"seleciona memoria convencional"}
};

int lib_debug = 0; /* =1 for debugging  */
struct task_table {
	void (*function)();
	int stack_words;
	char name[9];
	char terminal;
}*init_tbl=NULL;
struct task_table *load_task_table( );
char current_dir[65]="";
void *syslist;

#define ALARMES(s) liga_alarmes(s)

void alloc_sft() {
	void **handle_tbl;
	void *old_tbl;
	int *handle_cnt;
	char *s;
	int nfopen;
	nfopen = 100;
	handle_tbl=(void **)MK_FP(_psp,0x34);
	old_tbl=*handle_tbl;
    *handle_tbl = dos_alloc( (nfopen >> 4) + 1 );
	handle_cnt=MK_FP(_psp,0x32);
	set_bytes( *handle_tbl,0xff,nfopen );
	move_bytes( *handle_tbl,old_tbl,*handle_cnt );
	*handle_cnt = nfopen;
	s = (byte *)old_tbl;
/*	printf("\nold_tbl = %04x:%04x",FP_SEG(old_tbl),FP_OFF(old_tbl));
	printf("\n%02x %02x %02x %02x %02x %02x %02x",
		*s,*(s+1),*(s+2),*(s+3),*(s+4),*(s+5),*(s+6));
	printf("\nNew SFT = %04x:%04x",
		FP_SEG(*handle_tbl),FP_OFF(*handle_tbl));
	s = (byte *)(*handle_tbl);
	printf("\n%02x %02x %02x %02x %02x %02x %02x",
		*s,*(s+1),*(s+2),*(s+3),*(s+4),*(s+5),*(s+6));
*/
}

void liga_alarmes ( alarmes )
char *alarmes;
{
unsigned char term=TID;
unsigned int p=1;
int t,al=0;
	if (term>=32) return;
	for ( t=0 ; t<=5 ; t++ ) {
		if ( alarmes[t] == 'L')
			al = al | p;
		else if ( alarmes[t] == 'D' )
			al = al & ~p;
		else
			break;
		 p=p<<1;
	}
	setleds( al );
}

unsigned int *stk[NUMTERM+5];
char *begstk;
char *globalstk;
unsigned long totalstk;

static unsigned int alloc_stack()
{
    void *tmp;
    int i;
    unsigned int stacklen,n;
    unsigned long onestk;
    unsigned int normoff,normseg;

    /******* determine sum of all stacks areas *********/
    n=0;
    totalstk=0;
    for (i=0;i<NUMTERM+5;i++)
        if ((init_tbl+i)->stack_words) {
            n++;
            totalstk += ((init_tbl+i)->stack_words << 1 /*+ 200*/);
            /* alocacao ampliada em mais 200 bytes */
            onestk = ((init_tbl+i)->stack_words << 1);
        }
     /*totalstk += onestk;*/ /* reserva para caso de erro (BUG) */
/*printf("\n# processos = %d, total stack = %lu.",n,totalstk); getch();*/
    /******* allocate global area for stacks ******/
    begstk=globalstk = (char *)dos_alloc((totalstk >> 4) + 1);
    if (globalstk==NULL) {
        printf("\n***** Erro fatal: Falta memoria DOS *****");
        exit(1);
    }
    else {
        /*printf("\n***** Memoria DOS alocada *****");
        printf("\nBase: %04x:%04x, Size: %lu.\n",FP_SEG(globalstk),
            FP_OFF(globalstk),totalstk);*/
    }
/*printf("\nglobal stack pointer = %04x:%04x",
        FP_SEG(globalstk),FP_OFF(globalstk)); getch();
*/
    /******* assign each task's stack *******/
    for (i=0;i<NUMTERM+5;i++)
		if ((init_tbl+i)->stack_words) {
            /* stk[i] = (unsigned int *)globalstk; */
            /******* normalize stack pointer *********/
            normoff = FP_OFF(globalstk) & 0x0f;
            normseg = ((FP_OFF(globalstk)) >> 4) + FP_SEG(globalstk);
            globalstk = MK_FP(normseg,normoff);
            *((unsigned *)(stk+i)) = normoff;
            *(((unsigned *)(stk+i))+1) = normseg;
            globalstk += ((init_tbl+i)->stack_words << 1);
        }
            normoff = FP_OFF(globalstk) & 0x0f;
            normseg = ((FP_OFF(globalstk)) >> 4) + FP_SEG(globalstk);
            globalstk = MK_FP(normseg,normoff);
            tmp=dos_alloc(1000);
            dos_free(tmp);
    if (tmp==NULL) {
        printf("\n***** Erro fatal: Falta memoria DOS *****");
        exit(1);
    }
/*printf("\n_psp = %04x",_psp);
printf("\nfirst free segment = %04x",FP_SEG(tmp));*/
    return (unsigned int)((((unsigned long)FP_SEG(begstk) * 16L +
        (unsigned long)FP_OFF(begstk) -
        (unsigned long)_psp * 16L)/1024L)+1L);
}

static void inicia_processos( )
{
	int i,stacklen;
	int name_printed=0;
	for (i=0;i<NUMTERM+5;i++)
		if ((init_tbl+i)->stack_words) {
/*printf("\nCreate:stacklen=%d,term=%d,i=%d,stk=%04x:%04x,func=%04x:%04x",
        (init_tbl+i)->stack_words << 1,
		(init_tbl+i)->terminal,i,
		FP_SEG(stk[i]),FP_OFF(stk[i]),
		FP_SEG((init_tbl+i)->function),
		FP_OFF((init_tbl+i)->function) );
getch();
*/
            if (!name_printed) {
                name_printed++;
				printf("\nAplicao <%8.8s>, HandTerm #%d",
                    init_tbl->name,i);
			}
			else
                printf(",%d",i);
            stacklen = (init_tbl+i)->stack_words;
			create_task( (init_tbl+i)->terminal,
				stacklen,stk[i],
				(init_tbl+i)->function, get_ds() );
		}
       init_spooler();
        printf("\n");
}

void main( argc,argv )
int argc;
char **argv;
{
/*	void *tmp;*/
	unsigned int size;
	getargs( argc,argv,Argtab,ARGTABSIZE );
    printf("\n\n*** Rede de Microterminais HandTerm (MR) ***");
	printf("\nHandTerm Tecnologia -- 1993");

    if ((syslist=get_syslist())==NULL) {
        printf("\n\nHTDRV no encontrado!\n");
		exit(1);
	}
	get_srv_entry();
	if (check_installed() != 0) {
        printf("\n\nAplicao j instalada!\n");
		exit(2);
	}
/*
    printf("\nsyslist=%04x:%04x",FP_SEG(syslist),FP_OFF(syslist));
    getch();
*/
	_getcwd(current_dir,64);
	strcat(current_dir,"\\");
/*
    printf("\nDiretorio corrente: %s\n",current_dir);
    tmp = (void *)*syslist;
    printf("\nready=%04x:%04x",FP_SEG(tmp),FP_OFF(tmp));
	tmp = (void *)*((void **)syslist+1);
    printf("\nrunning=%04x:%04x",FP_SEG(tmp),FP_OFF(tmp));
*/
	init_tbl=load_task_table();
	alloc_sft();
    size = alloc_stack();
    /* size agora reflete Kb de mem convencional (menos pilhas) */
	inicia_processos();
    if (convmem==0) {
/*        printf("\nset_swapping: %04x,globalstk: %04x:%04x, KB(size): %d",_psp,
            FP_SEG(globalstk),FP_OFF(globalstk),
            ((FP_SEG(globalstk)-_psp)>>6)+1);
        getch();
*/
/*        if(!set_swapping(_psp,size+(totalstk >> 10) + 1))*/
        if(!set_swapping(_psp,((FP_SEG(globalstk)-_psp)>>6)+1))
            size=0;
    }
    else
        set_swapping(_psp,0);
/*    printf("\nSegmento do PSP = 0x%04x, Memria ocupada (code) %d Kbytes.",
        _psp,size);
*/
    /*dos_free(begstk);*/
    if (size || convmem) {
        printf("\n\nPrograma alocado na memria convencional.");
        printf("\nSize = %d, Convmem = %d\n",size,convmem);
        keep(size); /***** + 5 Kb ( BUG ?????? ) ******/
	}
/*    while (_signal(MAIN_START)) ;*/
/* da partida a todas as tarefas */
}

void stop_run( ) {
	ALARMES("DDD");
	mprintf("\f*** HandTerm ***    OFFLINE");
	while(1) htgetc();
}

void accept_inkey( buffer ) 
char *buffer;
{
	char c,s[4];
	c=0;
	c=inkey_asm();
	sprintf(s,"%03.3d",c);
	move_bytes(buffer,s,3);
}

void runtime_err( ) { }

void init_terminal( ) {
    void *tmp;
/*    wait(MAIN_START);*/
    if (TID>32) return;
	if (TID<32) {
/*        ALARMES("DDDDL");
        mprintf("\fInicializando\nAguarde...");
        suspend(100);
*/
        ALARMES("DLDDD");
        mprintf("\f\xdb\xdb\xdb HandTerm \xdb\xdb\xdbTerminal ativo!");
        flushkbd();
	}
    while(htgetc()!=DEL);
/*    tmp=MAIN_START;
    mprintf("\fmain_start: %04x:%04x.",FP_SEG(tmp),FP_OFF(tmp));
    htgetc();
*/
}

void display( buffer,len )
char *buffer;
int len;
{ /* anteriormente disp_glob() */
	while (len--)
		htputc(*buffer++);
}

void display_erase() { htputc('\f'); }

void newline() { htputc('\n'); }

/* end of MCLIBDIR.C */

