/*
**	Programa Residente para acesso aos Microterminais
**  	General Header file
**	Programadores:	Rildo Pragana
**
*/

/*	Caracteres especiais			*/

#define CR '\r'
#define DEL '\177'
#define BS '\b'

/*	Constantes relacionadas com a rede --- NAO MODIFIQUE --- */

#define NUMTERM 32		/* numero de terminais */
#define MAXFILA 64		/* tamanho da fila do display */
#define MAX 1000

#define MAXCAMPO 10
#define MAXCCHR 16

typedef unsigned char byte;

/*		Estruturas			*/

struct evento {
	byte make;		/* make/break */
	char tecla;		/* tecla associada ao evento */
};

struct msg_block {
	byte pend;			/* indica evento pendente no terminal */
	byte on_line;			/* indica terminal on-line */
	byte alarme;			/* estado dos alarmes (3 leds) */
	byte e,s;			/* ponteiros de entrada e saida
						na fila do display */
	byte pe,ps;			/* idem, p/impressora */
	int fila[ MAXFILA ];		/* fila de caracteres a serem
						enviados ao display */
};

/*
**	Declaracao de variaveis globais do MtNet
*/
extern struct msg_block terminais[NUMTERM];

/*
**	Prototipos -- funcoes utilitarias diversas
*/
void mtnet_init( int, char ** );
void mtnet_install( void );

/* 
**	rotina chamada quando existe um evento pendente do teclado
**	do HandTerm (tecla pressionada/solta)
*/
void process_event( byte, struct evento ); 

/*
**   liga_alarmes	-- permite o controle independente dos leds,
**			passando uma string como parametro, que contem:
**			1- cinco posicoes, correspondentes 
**			aos indicadores luminosos do HandTerm
**			2- um caracter L para "liga", D para "desliga" e
**			M para "mantem", em cada uma destas posicoes.
**
*/
