/*
**      Rotinas de comunicao com processo TSR
**      Micro Cobol Runtime Library
**
**      Rildo Pragana -- 08/92
**
*/
#include <stdio.h>
#include <dos.h>

#include "htnet.h"
#include "task.h"
#include "mccntrl.h"

void *wait_tsr_msg();
void end_tsr();
void TSRPROC( char * );

/*
**      TSRWAIT e' uma rotina chamada pelo processo "dummy"
**      para receber a proxima mensagem do programa externo.
**      A mensagem e' na forma de um buffer (ponteiro) que pode
**      ser lido ou escrito.
**      Uma vez sincronizada, e' chamada a subrotina
**      com o nome pre-determinado TSRPROC, para processar as
**      transferencias necessarias, recebendo os dois ponteiros
**      para o buffer residente e externo.  No final e' sinalizado
**      o processo externo, indicando o final da operacao.
*/
extern PROCESS *ready;
void TSRWAIT( )
{
    char *EXTBUF;
    void *d;
    unsigned char *rdy;
/*
    mprintf("\nChamarei wait_tsr_msg...");
    d=(void *)DUMMY_SEMAF;
    mprintf("\nEsperando dummy_semaf...%04x:%04x.",
        FP_SEG(d),FP_OFF(d));
    d = (void *) &ready;
    mprintf("\nReady queue: %04x:%04x.",
        FP_SEG(d),FP_OFF(d));
*/
/*    rdy = (char *)d-1;
    *rdy=1;
    wait(d);
    mprintf("\nCarregando EXTBUF...");
    EXTBUF = *((void **)((void **)syslist+8));
*/

    EXTBUF = (char *)wait_tsr_msg();
/*
        mprintf("\nExtbuf = %04x:%04x.",FP_SEG(EXTBUF),FP_OFF(EXTBUF));
        mprintf("\nExecutarei TSRPROC...EXTBUF = %04x:%04x.",
        FP_SEG(EXTBUF),FP_OFF(EXTBUF));
*/
    TSRPROC( EXTBUF );

/*    mprintf("\nChamarei end_tsr..."); intdebug();*/

    end_tsr();
}

void TSROPEN( ) {
}

void ADDRSTR( s,addr )
char *s;
char *addr;
{
	char tmp[10];
	sprintf(tmp,"%04x:%04x",FP_SEG(s),FP_OFF(s));
	move_bytes(addr,tmp,9);
}

/* end of TSRSEND.C */
