/*
 *  Interface com o Mdulo impressor (Itautec/Olivetti)
 *                 para o MCobol.
 *
 *  (C) Rildo Pragana 1992 -- Percomp Sistemas de Computao Ltda
 *  P.O. Box 7440 Recife Brazil
 *  E-mail: tecno@itep.itep.br (Internet)
 *
 */

#include <stdio.h>
#include <dos.h>
#include "mccntrl.h"

struct cobregs {
  char ah[3];
  char al[3];
  char bx[5];
  char cx[5];
  char dh[3];
  char dl[3];
  char cf;
};

void cvb1( s,r )
char *s;
unsigned char *r;
{
        *r = (*s-'0') * 100 + (*(s+1) - '0') * 10 + *(s+2) - '0';
}

void cvb2( s,r )
char *s;
unsigned *r;
{
        *r = (*s-'0') * 10000 + (*(s+1) - '0') * 1000 +
            (*(s+2) -'0') * 100 + (*(s+3) - '0') * 10 + *(s+4) - '0';
}

void cvs1( s,r )
char *s;
unsigned char r;
{
        char s1[8];
        sprintf( s1,"%03u",r );
        move_bytes( s,s1,3 );
}

void cvs2( s,r )
char *s;
unsigned r;
{
        char s1[8];
        sprintf( s1,"%05u",r );
        move_bytes( s,s1,5 );
}

void ITAU( CR, BUFFER )
struct cobregs *CR;
char *BUFFER;
{
   union REGS r,ro;
   struct SREGS sr;
   cvb1( CR->ah,&(r.h.ah) );
   cvb1( CR->al,&(r.h.al) );
   cvb1( CR->dh,&(r.h.dh) );
   cvb2( CR->bx,&(r.x.bx) );
   cvb2( CR->cx,&(r.x.cx) );
   sr.es = FP_SEG(BUFFER);
   r.x.si = FP_OFF(BUFFER);
   int86x( 0xf0,&r,&ro,&sr );
   cvs1( CR->ah,(ro.h.ah) );
   cvs1( CR->dh,(ro.h.dh) );
   cvs1( CR->dl,(ro.h.dl) );
   cvs2( CR->bx,(ro.x.bx) );
   cvs2( CR->cx,(ro.x.cx) );
   CR->cf = (unsigned char)((ro.x.cflag)&1) + (unsigned char)'0';
}

void HTOX( RH, RL, RX )
char *RH;
char *RL;
char *RX;
{
    unsigned hh,ll,xx;
    char s[8];
    hh = (*RH - '0') * 100 + (*(RH+1) - '0') * 10 + *(RH+2) -'0';
    ll = (*RL - '0') * 100 + (*(RL+1) - '0') * 10 + *(RL+2) -'0';
    xx = hh << 8 | ll;
    sprintf(s,"%05u",xx);
    move_bytes( RX,s,5 );
}

void XTOH( RX, RH, RL )
char *RX;
char *RH;
char *RL;
{
    unsigned hh,ll,xx;
    char *s[8];
    xx = (*RX -'0') * 10000 + (*(RX+1) - '0') * 1000 +
         (*(RX+2) -'0') * 100 + (*(RX+3) - '0') * 10 + *(RX+4) - '0';
    hh = xx >> 8;
    ll = xx & 0xff;
    sprintf( s,"%03u",hh );
    move_bytes( RH,s,3 );
    sprintf( s,"%03u",ll );
    move_bytes( RL,s,3 );
}

void BINMOVE( s,n )
char *s;
unsigned char *n;
{
  cvb1(s,n);	
}

/* end of ITAUTEC.C */
