/*
**  Cobol Compiler Library -- File Handling Module
**
**  by Rildo Pragana -- 1991
**  P.O. Box 7440 - Recife PE Brazil 50000
**
**  Revision history:
**	29-oct-91 Code implementation
**	24-dec-91 Separate library for files
**
*/

#include "mcoblib.h"
#include "math.h"

#define min(x,y) ((x)<(y) ? (x) : (y))
#define PRN_HANDLE *((int *)&(v->filepos))

extern char current_dir[];

int mc_open( f,v,mode )
struct file_desc *f;
struct var_fd *v;
int mode;
{
	char fname[64];
	unsigned long i,seekpos;
	int ac,ix;
#if	MICROSOFT == 2
	if (f->organization==1)
		v->filepos=64;
	else
		v->filepos=0;
#else
	v->filepos=0; 		/* set record counter to the first one */
#endif
	if (f->handle<=0) { 	/* do not open if it's already opened
				   and test error (-1) handle number */
		if (strchr(f->filename,'\\')==NULL)
			strcpy( fname,current_dir );
		else
			strcpy( fname, "" );
		strcat( fname,f->filename );
		strcat( fname,".arq" );
		switch(mode) {
		case 1: /* open input */
			if ((f->handle = _open( fname,
				O_RDONLY|O_BINARY))==-1) return 30;
				break;
		case 2: /* open i/o */
			if ((f->handle = _open( fname,
				O_RDWR|O_BINARY ))==-1) return 30;
				break;
		case 3: /* open output */
			if ((f->handle = _creat( fname,0))==-1) return 30;
				break;
		case 4: /* open extend */
			if ((f->handle = _open( fname,
				O_WRONLY|O_BINARY|O_APPEND ))==-1)
					return 30;
				break;
		default: return 97; /* unknown mode */
		}
		f->users=1; 	/* first user for this file */
	}
	else  {
		f->users++;
		return 0;
	}
	if (f->organization==1) {
		if (strchr(f->filename,'\\')==NULL)
			strcpy( fname,current_dir );
		else
			strcpy( fname, "" );
		strcat( fname,f->filename );
		strcat( fname,".ixd" );
		ac=_access(fname,0);
		if (ac==0 && mode!=3) {
			ix=open_index(fname,&(f->index),0);
			next_key( &(v->e),&(f->index) );
		}
		if (ac!=0 || ix!=IX_OK || mode==3) {
			/* try to re-index file */
		    make_index(fname,&(f->index),1);
		    if (mode!=3) {
#if	MICROSOFT==2
		if (f->organization==1)
			seekpos=64;
		else
			seekpos=0;
#else
			seekpos=0;
#endif
			for (i=0;;i++) {
				_lseek( f->handle, seekpos, SEEK_SET );
				if ( _read( f->handle, RECORD,
					f->reclen ) != f->reclen ) break;
				if (*(RECORD) == 0) {
#if MICROSOFT == 2
					if (f->organization==1)
						seekpos += f->reclen+3;
					else
						seekpos += f->reclen;
#else
					seekpos += f->reclen;
#endif
					continue; /* deleted */
				}
				move_bytes( v->e.key,RECORD+f->rec_index,
					 f->ixd_desc->len );
				*(v->e.key + f->ixd_desc->len)=0;
				v->e.recptr = seekpos;
				if (add_key( &(v->e), &(f->index) ) != IX_OK)
				{
					mprintf("\fErro na adicao  de chave");
					mgetkey();
					return 30;
				}
#if MICROSOFT==2
				if (f->organization==1)
					seekpos += f->reclen+3;
				else
					seekpos += f->reclen;
#else
				seekpos += f->reclen;
#endif
			} /* end of re-indexation */
		    }
		    first_key( &(f->index) );
		    next_key( &(v->e),&(f->index) );
		}
	}
/*	if (f->organization==4 && mode!=3)
		_lseek(f->handle,-1L,SEEK_END); */
		/* overwrite 0x1a at end */
	return 0;
}
