/*
**  Cobol Compiler Library -- File Handling Module
**
**  by Rildo Pragana -- 1991
**  P.O. Box 7440 - Recife PE Brazil 50000
**
**  Revision history:
**	29-oct-91 Code implementation
**	24-dec-91 Separate library for files
**
*/

#include "mcoblib.h"
#include "math.h"

#define min(x,y) ((x)<(y) ? (x) : (y))
#define PRN_HANDLE *((int *)&(v->filepos))

extern char current_dir[];

int read_into( f,v,buf,... )
struct file_desc *f;
struct var_fd *v;
char *buf;
{
	int rt;
	va_list args;
	if (f->organization==3 && f->access_mode!=1) {
		/* relative, not sequential */
		unsigned recn;
		long fpos;
		va_start(args,buf);	/* inicia 'args' apos 'buf' */
		recn=va_arg(args,unsigned);
		fpos= (long)(recn-1) * (long)f->reclen;
		rt=(int)_lseek(f->handle,fpos,SEEK_SET);
		if (rt==-1) return 31; /* seek error */
		rt = _read( f->handle, buf, f->reclen );
		if (rt==0) return 10; /* end of file */
		if (rt==-1) return 30; /* read error */
		v->filepos=fpos;
		va_end(args);
		return 0;
	}
	if (f->organization!=1 && f->access_mode==1)
	{ /* not indexed, sequential */
next_rec:	rt=(int)_lseek(f->handle,v->filepos,SEEK_SET);
		if (rt==-1) return 31; /* seek error */
		rt = _read( f->handle, buf, f->reclen );
		if (rt==0) return 10; /* end of file */
		if (rt==-1) return 30; /* read error */
#if MICROSOFT==2
		if (f->organization==1)
			v->filepos += f->reclen+3;
		else
			v->filepos += f->reclen;
#else
		v->filepos += f->reclen;
#endif
		if (*buf == 0) goto next_rec; /* deleted record */
	}
	else if (f->organization==1 && f->access_mode!=1)
	{ /* indexed, not sequential */
		move_bytes( v->e.key,buf+f->rec_index,
			f->ixd_desc->len );
		*(v->e.key + f->ixd_desc->len)=0;
/*mprintf("\fv->e.key -> '%s'\n",v->e.key); mgetkey();
*/		if (find_key( &(v->e), &(f->index))!=IX_OK) {
/*mprintf("record not found\n");
*/			return 23; /* record not found */
		}
		if(_lseek(f->handle,v->e.recptr,SEEK_SET)==-1) {
/*mprintf("seek error\n");
*/			return  31;
		}
		v->filepos=v->e.recptr;
		rt=_read( f->handle, buf, f->reclen );
		if (rt==0) {
/*mprintf("end of file\n");
*/			return 10; /* end of file */
		}
		if (rt==-1) {
/*mprintf("read error\n");
*/			return 30; /* read error */
		}
	}
	else if (f->organization==1 && f->access_mode==1)
	{ /* indexed, sequential */
		if (find_key( &(v->e),&(f->index))!=IX_OK) return 23;
		if (next_key( &(v->e),&(f->index))!=IX_OK) return 10;
		if (_lseek(f->handle,v->e.recptr,SEEK_SET)==-1) return 30;
		v->filepos=v->e.recptr;
		rt=_read( f->handle, buf, f->reclen );
		if (rt==0) return 10; /* end of file */
		if (rt==-1) return 30; /* read error */
	}
	return 0;
}
