/*
**  Cobol Compiler Library -- File Handling Module
**
**  by Rildo Pragana -- 1991
**  P.O. Box 7440 - Recife PE Brazil 50000
**
**  Revision history:
**      29-oct-91 Code implementation
**      24-dec-91 Separate library for files
**
*/

#include "mcoblib.h"
#include "math.h"

#define min(x,y) ((x)<(y) ? (x) : (y))
#define PRN_HANDLE *((int *)&(v->filepos))

extern char current_dir[];

int mc_read( f,v,... )
struct file_desc *f;
struct var_fd *v;
{
        int rt;
        va_list args;
        if (f->organization==3 && f->access_mode!=1) {
                /* relative, not sequential */
                unsigned recn;
                long fpos;
                va_start(args,v);       /* inicia 'args' apos 'v' */
                recn=va_arg(args,unsigned);
                fpos= (long)(recn-1) * (long)f->reclen;
                rt=(int)_lseek(f->handle,fpos,SEEK_SET);
                if (rt==-1) return 31; /* seek error */
                rt = _read( f->handle, RECORD, f->reclen );
                if (rt==0) return 10; /* end of file */
                if (rt==-1) return 30; /* read error */
                v->filepos=fpos;
                va_end(args);
                return 0;
        }
        if (f->organization!=1 && f->access_mode==1)
        { /* not indexed, sequential */
next_rec:       rt=(int)_lseek(f->handle,v->filepos,SEEK_SET);
                if (rt==-1) return 31; /* seek error */
                rt = _read( f->handle, RECORD, f->reclen );
                if (rt<f->reclen) return 10; /* end of file */
                if (*(RECORD)==0x1a) return 10; /* EOF char */
                if (rt==-1) return 30; /* read error */
#if MICROSOFT==2
                if (f->organization==1)
                        v->filepos += f->reclen+3;
                else
                        v->filepos += f->reclen;
#else
                v->filepos += f->reclen;
#endif
                if (*(RECORD) == 0) goto next_rec; /* deleted record */
        }
        else if (f->organization==1 && f->access_mode!=1)
        { /* indexed, not sequential */
                move_bytes( v->e.key,RECORD+f->rec_index,
                        f->ixd_desc->len );
                *(v->e.key + f->ixd_desc->len)=0;
/*mprintf("\fv->e.key %04x:%04x -> '%s'",FP_SEG(v->e.key[0]),
        FP_OFF(v->e.key[0]),v->e.key); mgetkey();*/
                if (find_key( &(v->e), &(f->index))!=IX_OK)
                        return 23; /* record not found */
                if(_lseek(f->handle,v->e.recptr,SEEK_SET)==-1)
                        return  31;
                v->filepos=v->e.recptr;
                rt=_read( f->handle, RECORD, f->reclen );
                if (rt==0) return 10; /* end of file */
                if (rt==-1) return 30; /* read error */
        }
        else if (f->organization==1 && f->access_mode==1)
        { /* indexed, sequential */
                if (find_key( &(v->e),&(f->index))!=IX_OK) return 23;
                if (next_key( &(v->e),&(f->index))!=IX_OK) return 10;
                if (_lseek(f->handle,v->e.recptr,SEEK_SET)==-1) return 30;
                v->filepos=v->e.recptr;
                rt=_read( f->handle, RECORD, f->reclen );
                if (rt==0) return 10; /* end of file */
                if (rt==-1) return 30; /* read error */
        }
        return 0;
}
