/*
**  Cobol Compiler Library -- File Handling Module
**
**  by Rildo Pragana -- 1991
**  P.O. Box 7440 - Recife PE Brazil 50000
**
**  Revision history:
**	29-oct-91 Code implementation
**	24-dec-91 Separate library for files
**
*/

#include "mcoblib.h"
#include "math.h"

#define min(x,y) ((x)<(y) ? (x) : (y))
#define PRN_HANDLE *((int *)&(v->filepos))

extern char current_dir[];

int rewrite_from( f,v,buf )
struct file_desc *f;
struct var_fd *v;
char *buf;
{
	if (f->organization != 1) { /* not indexed */
		if (f->organization != 3) /* not relative */
			v->filepos -= f->reclen;
		if (_lseek(f->handle,v->filepos,SEEK_SET)==-1L) return 21;
		if (_write(f->handle, buf, f->reclen)==-1) return 30;
	}
	if (f->organization==1) {
		/* indexed */
		if (find_key( &(v->e),&(f->index))!=IX_OK) return 23;
		if (memcmp( v->e.key,buf+f->rec_index,
				 f->ixd_desc->len )) return 99;
		if (_lseek(f->handle,v->e.recptr,SEEK_SET)==-1L) return 21;
		if (_write(f->handle, buf, f->reclen)==-1) return 30;
	}
	return 0;
}
