/*
**  Cobol Compiler Library -- File Handling Module
**
**  by Rildo Pragana -- 1991
**  P.O. Box 7440 - Recife PE Brazil 50000
**
**  Revision history:
**	29-oct-91 Code implementation
**	24-dec-91 Separate library for files
**
*/

#include "mcoblib.h"
#include "math.h"

#define min(x,y) ((x)<(y) ? (x) : (y))
#define PRN_HANDLE *((int *)&(v->filepos))

extern char current_dir[];
extern char *sortdesc;

int sort_return( f,v )
struct file_desc *f;
struct var_fd *v;
{
	int rt;
	if (v->releasing) {
		if ( first_key( &(f->index) )!=IX_OK )
			return 23;
		next_key( &(v->e),&(f->index) );
		v->releasing=0;
		v->filepos=v->e.recptr;
	}
	if (v->filepos<0) {
		_close(f->handle);
		f->handle=0;
		close_index(&(f->index));
		return 10; /* end of file */
	}
	if (_lseek(f->handle,v->e.recptr,SEEK_SET)==-1) return 30;
	rt=_read( f->handle, RECORD, f->reclen );
	if (rt==-1) return 30; /* read error */
	if (next_key( &(v->e),&(f->index))!=IX_OK)
		v->filepos=-1;
	else
		v->filepos=v->e.recptr;
	return 0;
}
