/*
**  Cobol Compiler Library -- File Handling Module
**
**  by Rildo Pragana -- 1991
**  P.O. Box 7440 - Recife PE Brazil 50000
**
**  Revision history:
**	29-oct-91 Code implementation
**	24-dec-91 Separate library for files
**
*/

#include "mcoblib.h"
#include "math.h"

#define min(x,y) ((x)<(y) ? (x) : (y))
#define PRN_HANDLE *((int *)&(v->filepos))

extern char current_dir[];

int write_adv_from( len,v,buf,opt,... )
int len;
struct var_fd *v;
char *buf;
int opt;
{
	va_list argp;
	int retcode;
	struct fld_desc *cnt_desc;
	char *cnt_buf;
	int lines=0;
	va_start( argp, opt );
	if ( opt>0 ) {
		cnt_desc = va_arg( argp,struct fld_desc * );
		cnt_buf = va_arg( argp,char * );
		lines=get_index( cnt_desc,cnt_buf );
		if (lines) lines--;
		if (opt==1) {
			retcode=write_prt_from( len,v,buf );
			for (;lines;lines--)
				_write(PRN_HANDLE,"\x0d\x0a",2);
		}
		else { /* opt==2 */
			for (;lines;lines--)
				_write(PRN_HANDLE,"\x0d\x0a",2);
			retcode=write_prt_from( len,v,buf );
		}
	}
	else if ( opt==-1 ) { /* before advancing page */
		retcode=write_prt_from( len,v,buf );
		_write(PRN_HANDLE,"\x0c",1);
	}
	else if ( opt==-2 ) { /* after advancing page */
		_write(PRN_HANDLE,"\x0c",1);
		retcode=write_prt_from( len,v,buf );
	}
	else /* only normal write (error?) */
		retcode=write_prt_from( len,v,buf );
	return retcode;
}
