/*
**  Cobol Compiler Library -- File Handling Module
**
**  by Rildo Pragana -- 1991
**  P.O. Box 7440 - Recife PE Brazil 50000
**
**  Revision history:
**	29-oct-91 Code implementation
**	24-dec-91 Separate library for files
**
*/

#include "mcoblib.h"
#include "math.h"

#define min(x,y) ((x)<(y) ? (x) : (y))
#define PRN_HANDLE *((int *)&(v->filepos))

int spool_number=0;
extern char current_dir[];

void open_prn( prn_port,f,v )
int prn_port;
struct file_desc *f;
struct var_fd *v;
{
	char fname[65],tmp[20];
	v->splrec = spool_number++;
	strcpy(fname,current_dir);
	sprintf(tmp,"SPL%05d\.\$MT",v->splrec);
	strcat(fname,tmp);
	PRN_HANDLE = _creat(fname,0);
	f->organization=4; /* special for spooler */
	f->users=prn_port; /* where to save prn_port */
}

void close_prn( f,v ) 
struct file_desc *f;
struct var_fd *v;
{
	char fname[65],tmp[20];
	_close(PRN_HANDLE);
	sprintf(fname,"%%%c",f->users+'0');
	strcat(fname,current_dir);
	sprintf(tmp,"SPL%05d\.\$MT",v->splrec);
	strcat(fname,tmp);
	submit_print(fname);
}

int write_prt( f,v )
struct file_desc *f;
struct var_fd *v;
{
	if (_write(PRN_HANDLE,RECORD,f->reclen)==-1) return 30;
	if (_write(PRN_HANDLE,"\x0d\x0a",2)==-1) return 30;
	return 0;
}

int write_adv( f,v,opt,... )
struct file_desc *f;
struct var_fd *v;
int opt;
{
	va_list argp;
	int retcode;
	struct fld_desc *cnt_desc;
	char *cnt_buf;
	int lines=0;
	va_start( argp, opt );
	if ( opt>0 ) {
		cnt_desc = va_arg( argp,struct fld_desc * );
		cnt_buf = va_arg( argp,char * );
		lines=get_index( cnt_desc,cnt_buf );
		if (opt==1) {
			retcode=write_prt( f,v );
			for (;lines;lines--)
				_write(PRN_HANDLE,"\x0d\x0a",2);
		}
		else { /* opt==2 */
			for (;lines;lines--)
				_write(PRN_HANDLE,"\x0d\x0a",2);
			retcode=write_prt( f,v );
		}
	}
	else if ( opt==-1 ) { /* before advancing page */
		retcode=write_prt( f,v );
		_write(PRN_HANDLE,"\x0c",1);
	}
	else if ( opt==-2 ) { /* after advancing page */
		_write(PRN_HANDLE,"\x0c",1);
		retcode=write_prt( f,v );
	}
	else /* only normal write (error?) */
		retcode=write_prt( f,v );
	return retcode;
}

/* end of MCPRINT.C */