/* MCobol Library -- printf functions */
/* Usar estas como substituto das identicas no MSC. Parametros
	da string de formato geral:

		% [flags] [largura] [.precisao] [l] tipo

	tipos possiveis:		
	b - binario
	d - decimal
	o - octal
	u - unsigned int
	x - hexadecimal
	q - numero 'duplo' em octal
	s - string
	c- caracter
	
	modificador opcional:
	l - long
	
	largura/precisao:
	? ou *  - obtem largura de um parametro que segue

	flags:
	- - alinhado `a esquerda
	0 - preenchido com zeros a esquerda
	
	tipos B,D,O,U,X - o mesmo que os acima, com caracteres maiusculos
	(Obs: nao tem "float" ou "double")
	
	Exemplos:

	int i;
	mprintf( "%7.5d",i ); --> inteiro em decimal com 7 posicoes,
					precisao de 5 digitos
	int i;
	mprintf( "%05d",i ); --> inteiro em 5 posicoes preenchido com zeros
	
	int largura,precisao;
	char *s1,*s;
	sprintf( s1,"%?.?s",largura,precisao,s ); --> string de largura 
				e precisao variaveis
	
	unsigned long int x;
	FILE *f;
	fprintf( f,"%-12ul",x ); --> inteiro sem sinal, alinhado a esquerda
*/	

int sprintf( char *,char *,... );
int fprintf( FILE *,char *,... );
int printf( char *,... );
int mprintf( char *,... );
int vsprintf( char *,char *,va_list );
int vfprintf( FILE *,char *,va_list );
int vprintf( char *,va_list );
