
/* 	
**	Functions for Console screen
**	(C) 1992 R. Pragana 
*/

#include <stdio.h>
#include <dos.h>
#include <fcntl.h>

int wherex() {
	union REGS inregs,outregs;
	inregs.h.ah = 0x03;
	inregs.h.bh = 0;
	int86(0x10,&inregs,&outregs);
	return (outregs.h.dl+1);
}

int wherey() {
	union REGS inregs,outregs;
	inregs.h.ah = 0x03;
	inregs.h.bh = 0;
	int86(0x10,&inregs,&outregs);
	return (outregs.h.dh+1);
}

void gotoxy( x,y )
int x,y;
{
	union REGS inregs,outregs;
	inregs.h.ah = 0x02;
	inregs.h.bh = 0;
	inregs.h.dh = y-1;
	inregs.h.dl = x-1;
	int86(0x10,&inregs,&outregs);
}

void clrscr() {
	union REGS inregs,outregs;
	gotoxy(	1,1 );
	inregs.h.ah = 0x09;
	inregs.h.al = ' ';
	inregs.h.bh = 0;
	inregs.h.bl = 7;
	inregs.x.cx = 2000;
	int86(0x10,&inregs,&outregs);
}

void freemem( segx ) 
unsigned segx;
{
	union REGS inregs,outregs;
	struct SREGS seg_regs;
	inregs.h.ah = 0x49;
	seg_regs.es = segx;
	int86x(0x21,&inregs,&outregs,&seg_regs);	
}

void set_bytes( buf,c,len )
char *buf;
char c;
int len;
{
	while (len--)
		*buf++=c;
}

/*char *move_bytes( dest,src,len ) 
char *dest;
char *src;
unsigned len;
{
	unsigned long destn,srcn;
	char *ret;
	ret=dest;
	destn = ((long)((FP_SEG(dest)))<<4) + (FP_OFF(dest));
	srcn  = ((long)((FP_SEG(src)))<<4)  + (FP_OFF(src));
	if (srcn<destn) {
		src+=(len-1);
		dest+=(len-1);
		while (len--)
			*dest-- = *src--;
	}
	else {
		while (len--)
			*dest++ = *src++;	
	}
	return (ret);
}*/

long _lseek( handle,offset,fromwhere ) 
int handle; 
long offset;
int fromwhere; {
	union REGS inregs,outregs;
	long new_offset;
	unsigned *newp;
	inregs.h.ah = 0x42;
	inregs.h.al = (unsigned char)fromwhere;
	inregs.x.bx = handle;
	inregs.x.cx = offset >> 16;
	inregs.x.dx = (unsigned int) offset;
	intdos(&inregs,&outregs);
	if (outregs.x.cflag & 1 /* carry flag */ )
		return -1L;
	newp = (unsigned *)&new_offset;
	*newp++ = outregs.x.ax;
	*newp   = outregs.x.dx;
	return new_offset;
}

long _filelength( handle ) 
int handle; {
	union REGS inregs,outregs;
	long len;
	unsigned int *lenp;
	inregs.h.ah = 0x42;
	inregs.h.al = 2;	/* use SEEK_END */
	inregs.x.bx = handle;
	inregs.x.cx = 0;
	inregs.x.dx = 0;
	intdos(&inregs,&outregs);
	if (outregs.x.cflag & 1 /* carry flag */ )
		return -1L;
	lenp = (unsigned *)&len;
	*lenp++ = outregs.x.ax;
	*lenp	= outregs.x.dx;
	return (len);
}

long _tell( handle ) 
int handle; {
	union REGS inregs,outregs;
	long pos;
	unsigned int *posp;
	inregs.h.ah = 0x42;
	inregs.h.al = 1;	/* use SEEK_CUR */
	inregs.x.bx = handle;
	inregs.x.cx = 0;
	inregs.x.dx = 0;
	intdos(&inregs,&outregs);
	if (outregs.x.cflag & 1 /* carry flag */ )
		return -1L;
	posp = (unsigned *)&pos;
	*posp++ = outregs.x.ax;
	*posp	= outregs.x.dx;
	return (pos);
}

/*static char tmp_dta_buffer[128]={0};
static char *tmp_dta=tmp_dta_buffer;*/

int _access( filename,amode )
char *filename;
int amode;
{
	union REGS inregs,outregs;
	struct SREGS seg_regs;
/*	inregs.h.ah = 0x1a;	/ * set DTA * /
	seg_regs.ds = FP_SEG(tmp_dta);
	inregs.x.dx = FP_OFF(tmp_dta);
	_intdosx(&inregs,&outregs,&seg_regs);
	inregs.h.ah = 0x4e;
	inregs.x.cx = 0;		/ * locate only normal files * /
	seg_regs.ds = FP_SEG(filename);
	inregs.x.dx = FP_OFF(filename);
	_intdosx(&inregs,&outregs,&seg_regs);
*/
	inregs.h.ah = 0x43;
	inregs.h.al = 0;	/* get attrib */
	seg_regs.ds = FP_SEG(filename);
	inregs.x.dx = FP_OFF(filename);
	_intdosx(&inregs,&outregs,&seg_regs);
	if (outregs.x.cflag & 1 /* carry flag */ )
		return -1;
	if ((amode==2) && (outregs.x.cx & 1))
		return -1;
	return 0;
}

int _close( handle )
int handle; {
	union REGS inregs,outregs;
	inregs.h.ah = 0x3e;
	inregs.x.bx = handle;
	intdos(&inregs,&outregs);
	if (outregs.x.cflag & 1) /* carry flag */
		return -1;
	return 0;
}

int _creat( filename,attrib ) 
char *filename;
int attrib; {
	union REGS inregs,outregs;
	struct SREGS seg_regs;
	inregs.h.ah = 0x3c;
	inregs.x.cx = attrib;
	seg_regs.ds = FP_SEG(filename);
	inregs.x.dx = FP_OFF(filename);
	_intdosx(&inregs,&outregs,&seg_regs);
	if (outregs.x.cflag & 1 /* carry flag */ )
		return -1;
	return (outregs.x.ax);
}

int _open( filename,oflags )
char *filename;
unsigned int oflags;
{
	union REGS inregs,outregs;
	struct SREGS seg_regs;
	int handle;
/*mprintf("\fOPEN: %s Oflags: %04x",filename,oflags); mgetkey();*/
	inregs.h.ah = 0x3d;
	inregs.h.al = oflags & 7;	/* modos O_TEXT & O_BINARY sao
					sempre binarios (s/translacao) */
	seg_regs.ds = FP_SEG(filename);
	inregs.x.dx = FP_OFF(filename);
	_intdosx(&inregs,&outregs,&seg_regs);
	if (outregs.x.cflag & 1 /* carry flag */ )
		return -1;
	handle = outregs.x.ax;
	if (oflags & O_APPEND)
		_lseek(handle,0,SEEK_END);
	return (handle);
}

int _read( handle,buf,len )
int handle;
char *buf;
unsigned len;
{
	union REGS inregs,outregs;
	struct SREGS seg_regs;
	inregs.h.ah = 0x3f;
	inregs.x.bx = handle;
	inregs.x.cx = len;
	seg_regs.ds = FP_SEG(buf);
	inregs.x.dx = FP_OFF(buf);
	_intdosx(&inregs,&outregs,&seg_regs);
	if (outregs.x.cflag & 1 /* carry flag */ )
		return -1;
	return (outregs.x.ax);
}

int _write( handle,buf,len )
int handle;
char *buf;
unsigned len;
{
	union REGS inregs,outregs;
	struct SREGS seg_regs;
	inregs.h.ah = 0x40;
	inregs.x.bx = handle;
	inregs.x.cx = len;
	seg_regs.ds = FP_SEG(buf);
	inregs.x.dx = FP_OFF(buf);
	_intdosx(&inregs,&outregs,&seg_regs);
	if (outregs.x.cflag & 1 /* carry flag */ )
		return -1;
	return (outregs.x.ax);
}

char *_getcwd( buf,buflen )
char *buf;
int buflen;
{
	union REGS inregs,outregs;
	struct SREGS seg_regs;
	inregs.h.ah = 0x19;	/* unidade de disco atual */
	intdos(&inregs,&outregs);
	*buf++ = 'A' + outregs.h.al;
	*buf++ = ':';
	*buf++ = '\\';
	inregs.h.ah = 0x47;	/* diretorio atual */
	inregs.h.dl = outregs.h.al + 1;
	inregs.x.si = FP_OFF(buf);
	seg_regs.ds = FP_SEG(buf);
	_intdosx(&inregs,&outregs,&seg_regs);
	return (buf);
}

/* end of MCVIDEO.C */
