/*
**	Modulo de comunicacao e instalacao
*/

#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <direct.h>
#include <memory.h>
#include <process.h>
#include <stdlib.h>
#include <malloc.h>

#include "mtn.h"
#include "task.h"
#include "getargs.h"

void keep_pgm( /* unsigned paragraphs, int sched_ticks */ );
void scheduler( );
void init_linha( );
void instala_int( );
void desinstala( );
void mtnet_exit( );

/*	Defines relacionados com comunicacao	*/

#define TPDSPLY 0   /* display */
#define TPTECLA 1   /* tecla/alarme */
#define TPPRN   2   /* impressora */
#define TPCONF  3   /* configuracao e status da impressora */
#define SENDTIPO( tty,tipo ) 	send_bits(5, tty); send_bits(2, tipo);
#define send_printer( tty, c ) SENDTIPO(tty,TPPRN); send_bits(8, c);
#define send_display( tty, c ) SENDTIPO(tty,TPDSPLY); send_bits(8, c);
#define send_endblk( ) send_bits(7,0x7d);

#define ARGTABSIZE (sizeof(Argtab)/sizeof(ARG))


/***************  V A R I A V E I S  ***********************/

extern SEMAF sioready, sdsp[], skey[], sprt[];
/*extern void *_heaptop; */ /* final da heap do Turbo C */

void get_bits( /*byte nbits , byte *c*/ );
void send_bits( /*byte nbits, byte dados*/ );

struct msg_block terminais[NUMTERM]={0};
unsigned int SRETARDO=1;
unsigned int LRETARDO=6;
unsigned int msg_blk_size=sizeof(struct msg_block);
unsigned int semaf_size=sizeof(SEMAF);
static unsigned paragraphs;
static unsigned malloc_blk=0;
static unsigned env_seg=0;
byte polling = 0;	/* indica polling em andamento */
static unsigned *port_base,base_off;
static int pporta=1;
int ftimer=8;
int din_port=0;
int dout_port=0;
static int mapmem=0;
int uninstall=0;
static int sched_ticks=10;
static int alocpar=40; /* default de 40 paragrafos alocados */
static int nfopen=20;
union REGS reg,oreg;
struct SREGS segr;

static ARG Argtab[] = {
/* 		Tabela de argumentos de mtnet_init			*/
/* 	switch	tipo	variavel	msg				*/
	{ 'd',	INTEGER, &ftimer,	"taxa de acesso ao display" },
	{ 'l',	INTEGER, (int *)&LRETARDO, "retardo longo" },
	{ 'c',	INTEGER, (int *)&SRETARDO, "retardo curto" },
	{ 'p',	INTEGER, &pporta, 
		"1, 2, 3 ou 4 (LPTn:) ou endereco da porta" },
	{ 'm',	BOOLEAN, &mapmem,	"mostra memoria alocada"},
	{ 'q',	BOOLEAN, &uninstall,	"desinstala pgm residente"},
	{ 's',  INTEGER, &sched_ticks,	"numero de ticks p/acesso ao OS"},
	{ 'a',	INTEGER, &alocpar, 
		"paragrafos de memoria (16 bytes) reservadas"},
	{ 'o',  INTEGER, &nfopen,	"handles para arquivos"}
};

int getargs( int, char **, ARG *, int );

/*********************************************************************/
/*
** Retorna com um evento onde 'make' sera 1 se a tecla esta pressionada e
** 0 caso contrario. Ja 'tecla' vira com o binario da tecla como especificado
** na documentacao da funcao 'trata_dados'
**
*/
struct evento get_key( tty )
byte tty;
{
	struct evento ev;
	byte c;

	/* manda alarme / recebe make+tecla em c */
	SENDTIPO( tty, TPTECLA );
	send_bits(3, terminais[tty].alarme);
	get_bits (5,  &c);
	terminais[tty].pend = 0;
	ev.make  = (c & 0x10) >> 4;
	ev.tecla = (char )c & 0x0f;
	return (ev);
}


/*
**  Retorna o configuracao do sistema e status da impressora do terminal
**  especificado
*/
byte get_config( tty )
byte tty;
{
	static byte config;
	SENDTIPO(tty, TPCONF);
	get_bits (8, &config);
	return(config);
}

void init_linha ()
{
	outportb( dout_port, 1 );			/* inicia linha */
	send_bits(5,0);		/* envia alguns zeros para posicionar os
						buffers de linha */
}

#define MIL 0x10000L
#define HIGH_BYTE(x) ((x)>>8)
#define LOW_BYTE(x) ((x)&0xff)
unsigned pre_calc_fat[] =
	{ 0,MIL/1,MIL/2,MIL/3,MIL/4,MIL/5,MIL/6,MIL/7,MIL/8,MIL/9,MIL/10 };

static void init_8253( fator )
int fator;
{
   unsigned i;
   i = pre_calc_fat[fator];
   outportb ( 0x43,0x36 );	/* low+high byte, onda quadrada */
   outportb ( 0x40,  LOW_BYTE(i)); 
   outportb ( 0x40,  HIGH_BYTE(i)); 
}

void list_mem( ) {
	unsigned *env;
	union {
		void *p;
		struct {
			unsigned o;
			unsigned s;
		} w;
	} heap_end;
	/* Devera' preparar a variavel _heaptop (_heapbase e' constante)
	   do Turbo C para apontar para o final da heap permitida */
	unsigned len;
	heap_end.p = malloc(1);
	free( heap_end.p );
	len = heap_end.w.s + (heap_end.w.o/16)+1+alocpar;
	paragraphs= (unsigned)(len - _psp);
	env = MK_FP(_psp,0x2c); /* environment pointer in PSP */
	env_seg = *env;
	if (mapmem!=0) {
		printf("\nInstalado na porta 0x%04x\n",din_port+1);
		printf("\nApontadores do processo (todos em HEX):\n\n");
		printf("Segmento do PSP = 0x%04x,\n",_psp);
		printf("Segmento do environment = 0x%04x\n",env_seg);
		printf("Segmento da area de variaveis = 0x%04x\n",malloc_blk);
		printf("Memoria ocupada em paragrafos = %d\n",paragraphs);
	};
}

struct mcb {
	unsigned char typ;
	unsigned owner;
	unsigned size;
} *mcbp;
unsigned *mcbseg;

void mtnet_uninstall( ) {
	disable();
	polling++;		/* bloqueia polling p/ sair */
	while (running != NULL) ;
	*port_base=din_port-1;	/* restitui endereco da LPTn no bios */
	init_8253(1);		/* retorna ao valor original */
	desinstala();		/* restitue vetores de interrupcao default */
/*	enable();*/
	/* while ( (polling!=0) || (gerando!=0) ); */
/*	freemem( env_seg );
	freemem( malloc_blk );
	freemem( _psp );
*/
	reg.h.ah = 0x52;
	_intdosx( &reg,&oreg,&segr );
	mcbseg = MK_FP( segr.es,oreg.x.bx-2 );
	mcbp = MK_FP( *mcbseg,0 );
/*printf( "MCB: %04x:%04x\nPSP: %04x\n",FP_SEG(mcbp),FP_OFF(mcbp),_psp);*/
	while( mcbp->typ == 0x4d ) {
		if (mcbp->owner == _psp)
			freemem( FP_SEG( mcbp ) + 1 );
		mcbp = MK_FP( FP_SEG( mcbp ) + mcbp->size + 1 ,
				FP_OFF( mcbp ) );
	}

}

void mtnet_init( argc,argv  )
int argc;
char **argv;
{
	void **handle_tbl;
	void *old_tbl;
	int *handle_cnt;
	unsigned *blk;
	byte i;
	getargs( argc, argv, Argtab, ARGTABSIZE );
	if (uninstall!=0) { /* switch p/desinstalar */
		reg.x.ax=0xef00;
		int86( 0x2f, &reg, &oreg );
		if ((oreg.x.ax & 0x0f)==0)
			fprintf(stderr,"\nMtNet nao esta' instalado!\n");
		else {
			reg.x.ax=0xef0f;
			int86( 0x2f,&reg,&oreg );
			printf("\nMTNet retirado da memoria\n");
		}
		exit(0);
	};
	reg.x.ax=0xef00;	/* Int2f-ef, funcao 00 - get init status */
	int86( 0x2f, &reg, &oreg );
	if ( (oreg.x.ax & 0x0f) != 0 ) {
		fprintf( stderr,"\nMtNet ja' instalado!\n");
		exit(0);
	}
	switch(pporta) {
		case 1:
		case 2:
		case 3:
		case 4: {
			base_off = (pporta-1)*2+8;
			port_base = MK_FP( 0x40, base_off );
			if ( (*port_base) == 0 ) {
				fprintf(stderr,
				"\nLPT%1d: nao instalada ou em uso!",pporta);
				exit(1);
			}
			disable();
			dout_port=(*port_base)+2;
			din_port=(*port_base)+1;
			*port_base=0;
			enable();
			/* LPT1: --> dout_port=0x37a; din_port=0x379; */
			/* LPT2: --> dout_port=0x3be; din_port=0x3bd; */
			break; }
		default: {
			dout_port = pporta+2;
			din_port = pporta+1;
		}
	}
	blk = (unsigned *)malloc(1);
			/* first blk alloc to free all memory later */
	malloc_blk = FP_SEG( blk ); /* save its segment */
	if (nfopen>20) {
		handle_tbl=(void **)MK_FP(_psp,0x34);
		old_tbl=*handle_tbl;
		*handle_tbl = calloc( nfopen,sizeof(byte) );
		handle_cnt=MK_FP(_psp,0x32);
		set_bytes( *handle_tbl,0xff,nfopen );
		move_bytes( *handle_tbl,old_tbl,*handle_cnt );
		*handle_cnt = nfopen;
	}
	if (ftimer<1 || ftimer>20) {
		fprintf(stderr,
		"\nFator de acesso ao display deve ser de 1 a 10!");
		exit(1);
	}
	for (i=0;i<NUMTERM;i++) {
		terminais[i].alarme=0;	/* desliga todos os alarmes */
		terminais[i].e = terminais[i].s = 0;
		terminais[i].pe = terminais[i].pe = 0;
	}
}

void mtnet_install( )
{
	clrscr();
	polling++;		/* indica polling em andamento
				   sera desligado em keep_pgm */
	init_linha();	/* inicia linha enviando 00000 */
	printf("\nMTNet V3.4 - (c) 1990,1992 TWR Informatica Ltda.\n");
	list_mem();
	disable();
	init_8253(ftimer); /* programa timer */
	keep_pgm(paragraphs,sched_ticks);
}

/* Final do Modulo */
