/*
**	Programa Residente para acesso aos Microterminais
**	TWR Informatica Ltda -- Recife, 17 de Maio de 1990
**  	General Header file
**	Programadores:	Rildo Pragana, Frederico Cavalcanti,
**			Antonio Brasileiro, Luiz Borba e Fabio Furtado
**
**	Release: 3.0	-	14/2/91
**	16/abril/91 RP modificacoes nas estruturas
*/

/*	Caracteres especiais			*/

#define CR '\r'
#define DEL '\177'
#define BS '\010'

/*	Constantes relacionadas com a rede --- NAO MODIFIQUE --- */

#define NUMTERM 20		/* numero de terminais */
#define MAXFILA 64		/* tamanho da fila do display */
#define MAX 1000

#define MAXCAMPO 10
#define MAXCCHR 16

typedef unsigned char byte;

/*		Estruturas			*/

struct evento {
	byte make;		/* make/break */
	char tecla;		/* tecla associada ao evento */
};

struct msg_block {
	byte pend;			/* indica evento pendente no terminal */
	byte on_line;			/* indica terminal on-line */
	byte alarme;			/* estado dos alarmes (3 leds) */
	byte e,s;			/* ponteiros de entrada e saida
						na fila do display */
	byte pe,ps;			/* idem, p/impressora */
	int fila[ MAXFILA ];		/* fila de caracteres a serem
						enviados ao display */
};

/*
**	Declaracao de variaveis globais do MtNet
*/
extern struct msg_block terminais[NUMTERM];

/*
**	Prototipos -- funcoes utilitarias diversas
*/
void mtnet_init( int, char ** );
void mtnet_install( void );

/*
**	Prototipos -- funcoes utilitarias diversas
*/
void process_event( byte, struct evento );

/*
**   liga_alarmes	-- permite o controle independente dos alarmes,
**			passando uma string como parametro, que contem:
**			1- tres posicoes, correspondentes (da esquerda para
**			a direita) aos tres indicadores luminosos do
**			microterminal: vermelho, amarelo e verde;
**			2- um caracter L para "liga", D para "desliga" e
**			M para "mantem", em cada uma destas posicoes.
**			Uma chamada "MMM" e' totalmente desnecessaria,
**			uma vez que os alarmes estao armazenados indepen-
**			dentemente para cada terminal e retem o seu
**			conteudo.
**
*/
