/*
** MTNet -- Spooler de impressao
** R. Pragana -- 09/Jun/91
**
** 05/06/92 modified for MSC
** 07/15/92 calling device driver
*/

/*#define TESTE 1*/

#include "mcoblib.h"

/* ------ parametros para uso do spooler --------*/

#define SPLFILES 40             /* qtd de arquivos maxima para spooler  */

#ifndef TESTE
static SEMAF spl_empty={0,NULL};
#endif

static char spl_queue[SPLFILES][64];
static int prtn_queue[SPLFILES];
static char buffer[512];
static char *devices[20] = {
               "LPT1    ","LPT2    ","LPT3    ","LPT4    ",
               "COM1    ","COM2    ","COM3    ","COM4    ",
               "COM5    ","COM6    ","COM7    ","COM8    ",
               "COM9    ","COM10   ","COM11   ","COM12   ",
               "COM13   ","COM14   ","COM15   ","COM16   " };

int submit_print( char * );
static void spool_proc( void );
void set_prt_int24( void );
void rst_prt_int24( void );

#define PRN_TMOUT 1000

#define RETRY 3

typedef struct devhdr {
     struct devhdr *next;
     unsigned attr;
     unsigned strat;
     unsigned intr;
     char name[8];
} DEVICE;

void write_prn( int , char *, int ); /* assembler --> spoola.asm */
void write_device( DEVICE *, char *, int );

int write_prnc( int, char *, int );

int write_prnc( port,buf,cnt )
int port;
char *buf;
int cnt;
{
     union REGS iregs,oregs;
      int status,tempo,rtry;
     while (cnt) {
            status = 0;
            tempo = 0;
           rtry=100;
          while (!status) {
            iregs.x.ax = 0x0300;
            iregs.x.dx = port;
            int86(0x14,&iregs,&oregs);
                  if ((oregs.x.ax & 0x2010) != 0x2010) {
                         status = 0;
                         tempo++;
                         if (tempo == 200) {
                              suspend(6);
                              tempo = 0;
                              if ((--rtry)==0) return -1;
                         }
                  }
               else
                    status = 1;
       }
       iregs.x.ax = 0x0100 | *buf++;
       iregs.x.dx = port;
       int86(0x14,&iregs,&oregs);
          cnt--;
     }
     return 0;
}

DEVICE *open_device( name )
char *name;
{
     union REGS iregs,oregs;
     struct SREGS cregs;
     unsigned sg,of,*devlist;
     char *devname;
     void (*func)();
     int i;
     iregs.x.ax=0x5200;
     intdosx(&iregs,&oregs,&cregs);
     devlist=MK_FP(cregs.es,oregs.x.bx+0x22);
     while (FP_OFF(devlist)!=0xffff) {
          devname = ((char *)devlist) + 0x0a;
          for (i=0;i<8;i++) {
               if (*(devname+i)!=*(name+i)) break;
          }
          if (i==8) {
               /* chama rotina de estrategia com
                  ES:BX apontando para o "request header"
                  seguida de interrupcao do device, funcao "open"
               func = MK_FP( FP_SEG(devlist),*(devlist+3) );
               (*func)();
               func = MK_FP( FP_SEG(devlist),*(devlist+4) );
               (*func)(); */
               return ((DEVICE *)devlist);
          }
          of=*devlist;
          sg=*(devlist+1);
          devlist=MK_FP(sg,of);
     }
     return NULL;
}

void close_device( dev )
DEVICE *dev;
{
     dev = NULL;
}

/* Spool de Impressao */
static void spool_proc( ) {
int fd;
int i,have_file=0;
int nchar;
DEVICE *dev;
#ifndef TESTE
while (1) {
#endif
     while (have_file!=0) {
          have_file=0;
          for (i=0;i<SPLFILES;i++) {
               if (spl_queue[i][0]!=0) {
                    have_file++;
                    /* suspend(1); */
                    fd=_open(spl_queue[i],O_RDONLY|O_BINARY);
                    if (prtn_queue[i]>=4 && prtn_queue[i]<=7)
                      do {
                          nchar=_read(fd,buffer,512);
                          if (nchar>0) {
                             if (write_prnc(prtn_queue[i]-4,buffer,nchar)) {
                                   /*htputs("\fErro write..."); htgetc();*/
                                   break;
                             }
                             suspend(2);
                          }
                      } while (nchar>0);
                    else {
                      dev=open_device(devices[prtn_queue[i]]);
                      if (dev!=NULL) {
                        do {
                            nchar=_read(fd,buffer,512);
                            if (nchar>0) {
                                if (write_device(dev,buffer,nchar))
                                       break;
                                suspend(2); /* permite outros rodarem */
                            }
                        } while (nchar>0); /* do */
                        close_device(dev);
                      }
                    }
                    close(fd);
                    spl_queue[i][0]=0;
               } /* if */
          } /* for */
     } /* while */
#ifndef TESTE
    wait(&spl_empty);
#endif
    have_file=1;
#ifndef TESTE
} /* while(1) */
#endif
}

int submit_print( fname )
char *fname; {
     int i;
     byte prtn=0;
     for (i=0;i<SPLFILES;i++) {
          if (spl_queue[i][0]==0) {
               if (*fname=='%') {
                    fname++;
                    prtn=(*fname++)-'0';
               }
               prtn_queue[i]=prtn;
               strcpy(spl_queue[i],fname);
#ifndef TESTE
               _signal(&spl_empty);
#else
               spool_proc();
#endif
               return 0;
          }
     }
}

#ifndef TESTE
static unsigned int stack[500];

void init_spooler( ) {
     create_task( 0x2f,500,stack,spool_proc,get_ds());
}
#else
int _open( filename,oflags )
char *filename;
unsigned int oflags;
{
     union REGS inregs,outregs;
     struct SREGS seg_regs;
     int handle;
     inregs.h.ah = 0x3d;
     inregs.h.al = oflags & 7;
     seg_regs.ds = FP_SEG(filename);
     inregs.x.dx = FP_OFF(filename);
     intdosx(&inregs,&outregs,&seg_regs);
     if (outregs.x.cflag & 1 /* carry flag */ )
          return -1;
     handle = outregs.x.ax;
     if (oflags & O_APPEND)
          lseek(handle,0,SEEK_END);
     return (handle);
}

int _read( handle,buf,len )
int handle;
char *buf;
unsigned len;
{
     union REGS inregs,outregs;
     struct SREGS seg_regs;
     inregs.h.ah = 0x3f;
     inregs.x.bx = handle;
     inregs.x.cx = len;
     seg_regs.ds = FP_SEG(buf);
     inregs.x.dx = FP_OFF(buf);
     intdosx(&inregs,&outregs,&seg_regs);
     if (outregs.x.cflag & 1)
          return -1;
     return (outregs.x.ax);
}

void suspend( delay )
unsigned delay; { }

void main() {
     submit_print( "%4spool.mc" );
}
#endif

/* end of SPOOL.C */


