/*
**	Teste de swapping com a memoria XMS
*/

#include <stdio.h>
#include <dos.h>
#include <io.h>

extern void (*xms)();

unsigned int xmshnd;
struct xmsparm {
	unsigned long size;
	unsigned int srchnd;
	unsigned long srcoffset;
	unsigned int dsthnd;
	unsigned long dstoffset;
}xmsp;

void iswap() { /* inicializa swap handler */
	union REGS iregs,oregs;
	struct SREGS sr;

	printf("\nChecking XMS installation");
	iregs.x.ax = 0x4300; /* -- check XMS installation */
	int86(0x2f,&iregs,&oregs);
	if (oregs.h.al != 0x80) { /* driver not installed */ 
		printf("\nDriver not installed");
		exit(1);
	}
	printf("\nXMS support detected");
	iregs.x.ax = 0x4310; /* get xms driver entry point */
	/*int86x(0x2f,&iregs,&oregs,&sr);
	xms = MK_FP( sr.es,oregs.x.bx );*/

	get_xms_entry();
	printf("\nXMS handler address: %04X:%04X.",
		FP_SEG(xms),FP_OFF(xms));
	getch();
	xmshnd = alloc_xms( 1 ); /* funcao em assembler p/allocar */
	printf("\nXMS handle for block: %04X.\n=============",xmshnd);
}

void mswapin(s)
char *s;
{
	union {
		unsigned long p;
		struct {
			unsigned l;
			unsigned h;
		}w;
	} x;
	xmsp.size = 132L;
	xmsp.srchnd = 0;
	x.w.l = FP_OFF(s);
	x.w.h = FP_SEG(s);
	xmsp.srcoffset = x.p;
	printf("\nSwapin: src_ptr: %04X:%04X.",
		x.w.h,x.w.l);
	xmsp.dsthnd = xmshnd;
	xmsp.dstoffset = 0L;
	
	printf("\nSwapin: src: %08lX dst: %08lX.",
		xmsp.srcoffset,xmsp.dstoffset );
	printf("\nXMS swap returned %02X.",
			xms_swap(FP_OFF(xmsp)) ); 
}

void mswapout(s)
char *s;
{
	union {
		unsigned long p;
		struct {
			unsigned l;
			unsigned h;
		}w;
	} x;
	xmsp.size = 132L;
	xmsp.dsthnd = 0L;
	x.w.l = FP_OFF(s);
	x.w.h = FP_SEG(s);
	xmsp.dstoffset = x.p;
	xmsp.srchnd = xmshnd;
	xmsp.srcoffset = 0L;
	
	printf("\nSwapout: src: %08lX dst: %08lX.",
		xmsp.srcoffset,xmsp.dstoffset );
	printf("\nXMS swap returned %02X.",
			xms_swap(FP_OFF(xmsp)) ); 
}

void main() {
	char s[133];
	iswap();
	printf("\nInicio do programa\n1STR: ");
	gets(s);
	mswapin(s);
	printf("\n2STR: ");
	gets(s);
	printf("\nSegunda string: %s",s);
	mswapout(s);
	printf("\nString anterior: %s",s);
}
