;
;  Rotina auxiliar para processamento da interrupcao 2Fh
;
PROC2F_TEXT     segment byte public 'CODE'
DGROUP  group   _DATA
        assume  cs:PROC2F_TEXT,ds:DGROUP
PROC2F_TEXT     ends

_DATA   segment word public 'DATA'
d@      label   byte
d@w     label   word
_DATA   ends

extrn   _keys_sent:far,__signal:far,_wait:far

PROC2F_TEXT     segment byte public 'CODE'
        assume  cs:PROC2F_TEXT,ds:DGROUP

OldInt2fW       label   word
OldInt2f        dd      0
dummy_semaf     dd      0
                dw      0
dummy_rdy       db      0
dummy_end       db      0
bufptr          label   word
                dd      0

        public _set_2fint
_set_2fint proc    far
        push    es                      ; get OldInt2f at 86 interrupt table
        mov     ax,352fh
        int     21h
        mov     word ptr cs:[OldInt2fW],bx
        mov     ax,es
        mov     word ptr cs:[OldInt2fW+2],ax
        pop     es
        push    ds                      ; set new Int2f vector
        mov     ax,cs
        mov     ds,ax
        mov     ax,252fh
        mov     dx,offset PROC2F_TEXT:_Int2fNew
        int     21h
        pop     ds
        ret
_set_2fint endp

        public  _res_2fint
_res_2fint proc    far
        push    ds                      ; restore Int2f vector
        mov     ax,word ptr cs:[OldInt2fW]
        mov     ds,ax
        mov     ax,252fh
        mov     dx,word ptr cs:[OldInt2fW+2]
        int     21h
        pop     ds
        ret
_res_2fint endp

_Int2fNew       proc far
        sti
        cmp     ah,0efh          ; MTNet multiplex interrupt
        jne     I2f1
        cmp     al,81h           ; communication sub-function
	jne     I2f2
I2f9:   test    byte ptr cs:dummy_rdy,0ffh      ; wait until dummy ready
	jz      I2fnr
	push	ax
	push    ds
        mov     ax,DGROUP
        mov     ds,ax
        mov     ax,es
        mov     word ptr cs:[bufptr+2],ax
        mov     word ptr cs:[bufptr],dx
        mov     byte ptr cs:dummy_rdy,0         ; it will not be rdy anymore
;	mov     byte ptr cs:dummy_end,0         ; same with finish flag
        push    cs
        mov     ax,offset cs:dummy_semaf
        push    ax
        call    far ptr __signal                ; wake-up dummy proc
        add     sp,4
        pop     ds
;I2f8:   test    byte ptr cs:dummy_end,0ffh
;	jz      I2f8
        pop     ax
	mov	al,1			; return OK
	jmp     I2fS
I2f2:   cmp     al,82h			; return dummy_end flag
	jne     I2f1
	cli
	mov	al,byte ptr cs:dummy_end
	mov	byte ptr cs:dummy_end,0
	sti
	jmp     I2fS
I2fnr:	mov	al,0			; return not ready
	sti
	jmp	I2fS
I2f1:   cli
        jmp     dword ptr cs:[OldInt2f]
I2fS:   iret
_Int2fNew       endp

        public  _wait_tsr_msg
_wait_tsr_msg   proc    far
        push    bp
        mov     bp,sp
        mov     byte ptr cs:dummy_rdy,1
        push    cs
        mov     ax,offset dummy_semaf
        push    ax
        call    far ptr _wait
        add     sp,4
        mov     dx,word ptr cs:[bufptr+2]
        mov     ax,word ptr cs:[bufptr]
        pop     bp
        ret
_wait_tsr_msg   endp

        public  _end_tsr
_end_tsr        proc    far
        mov     byte ptr cs:dummy_end,1
        ret
_end_tsr        endp

PROC2F_TEXT     ends
        end
