/*
**      Biblioteca MCobol -- rotinas XMTTRAN e RECTRAN
**			     rotinas ATIVATERMINAL e AGUARDAATIVACAO
**
**      XMTTRAN: Envia mensagem para o processo com ID #33 (Dummy)
**
**      Parametros: MSG -- campo com a mensagem
**		    CNT -- tamanho da mensagem (campo de 3 posicoes)
**
**	RECTRAN: Recebe mensagem (a ser usada pelo processo dummy)
**		 MSG -- buffer aonde colocar a mensagem
**		 CNT -- tamanho (maximo) da mensagem, campo de 3 posicoes
**
**      ATIVATERMINAL: Indica ao terminal dado que este deve ser ativado
**		 TERM -- campo numerico (2 posicoes) com o terminal
**
**	AGUARDAATIVACAO: Bloqueia o terminal dado ate' que outro processo
**			 chame a rotina ATIVATERMINAL com o terminal
**			 correspondente
**
**	TICKSWAIT: Retardo (inatividade) de duracao controlada
**		 TEMPO -- duracao em ticks (2 posicoes)
**
**	SVCURSOR: Salva posicao corrente do cursor da console
**	RSCURSOR: Restaura posicao do cursor da console
*/
#include <stdio.h>
#include <io.h>
#include <string.h>
#include <dos.h>
#include <conio.h>

#include <htnet.h>
#include <task.h>


static SEMAF dummy_sleep={0,NULL};
static struct mailbox_type {
	char *msg;
	int cnt;
	SEMAF in_process;
	struct mailbox_type *next;
};

static struct mailbox_type *dummy_mailbox=NULL;

static SEMAF terminal_ativo[NUMTERM]={0,NULL};

void XMTTRAN( MSG,CNT ) 
char *MSG;
char *CNT;
{
	struct mailbox_type mailbox,*tmp;
	mailbox.msg = MSG;
	mailbox.cnt = (*CNT - '0')*100 + (*(CNT+1) - '0')*10 +
			*(CNT+2) - '0';
	mailbox.in_process.p = NULL;
	mailbox.next=NULL;
	tmp=dummy_mailbox;
	if (tmp==NULL)
		dummy_mailbox=&mailbox;
	else {
		while (tmp->next != NULL) tmp=tmp->next;
		tmp->next=&mailbox;
	}
	_signal(&dummy_sleep);
	wait(&(mailbox.in_process));
}
void RECTRAN( MSG,CNT ) 
char *MSG;
char *CNT;
{
	int cnt;
	struct mailbox_type *mailbox;
	if (dummy_mailbox==NULL)
		wait(&dummy_sleep);
	mailbox = dummy_mailbox;
	dummy_mailbox = dummy_mailbox->next;
	cnt = (*CNT - '0')*100 + (*(CNT+1) - '0')*10 +
			*(CNT+2) - '0';
	if (mailbox->cnt<=cnt)
		move_bytes( MSG, mailbox->msg, mailbox->cnt );
	_signal(&(mailbox->in_process));
}

void AGUARDAATIVACAO( ) {
	wait(&(terminal_ativo[TID]));
	while (tec_ent[TID]!=tec_sai[TID]) mgetkey();
}

void ATIVATERMINAL( term ) 
char *term;
{
	int t;
	t= (*term - '0') * 10 + *(term+1) - '0';
	_signal(&terminal_ativo[t]);
}

static unsigned char xpos,ypos;
void SVCURSOR( ) {
	xpos=wherex();
	ypos=wherey();
}

void RSCURSOR( ) {
	gotoxy(xpos,ypos);
}

/* end of XMTTRAN.C */
